/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package teajay.bytecode.attributes.code;

import teajay.bytecode.OpCode;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public enum CMode {
    Byte(OpCode.i2b),
    Char(OpCode.i2c),
    Double(OpCode.i2d),
    Float(OpCode.i2f),
    Long(OpCode.i2l),
    Short(OpCode.i2s);
    
    final OpCode opcode;
    
    private CMode(OpCode opcode) {
        this.opcode = opcode;
    }
}
