/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package teajay.bytecode.cpool;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public class IntegerInfo extends U4Info {
    public IntegerInfo(int value) {
        super(CPoolTag.Integer, value);
    }
       
    public IntegerInfo(boolean value) {
        super(CPoolTag.Integer, value ? 1 : 0);
    }
    
    public int getIntegerValue() {
        return getRawValue();
    }
    
    @Override
    public String toString() {
        return this.getClass().getSimpleName() + ": " + this.getIntegerValue();
    }
    
    @Override
    public boolean equals(Object obj) {
        return (obj instanceof IntegerInfo) && super.equals(obj);
    }

    @Override
    public int hashCode() {
        int hash = 61 * super.hashCode();
        return hash;
    }
    
    @Override
    public IntegerInfo clone() {
        return new IntegerInfo(getIntegerValue());
    }
}
