/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package teajay.bytecode.util;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
public final class StringIterator {
    private final char[] str;
    private final String tmp;
    private int pos = 0;
    
    public StringIterator(String str) {
        this.str = str.toCharArray();
        this.tmp = str;
    }

    public boolean hasNext() {
        return pos < str.length;
    }

    public char next() {
        return str[pos++];
    }
    
    public char peek() {
        return str[pos];
    }
    
    @Override
    public String toString() {
        return tmp;
    }
}
