/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import exceptions.CompilerException;
import java.util.LinkedList;
import lexer.Symbol;

/**
 *
 * @author Michael Burzan
 */
public class ArrayInitializerNode extends SyntaxNode {

    private VariableInitializerNode varInitHead = null;
    private LinkedList<VariableInitializerNode> vList = null;
    private boolean hasEndComma = false;

    public ArrayInitializerNode(Symbol s) {
        super(s);

    }

    public ArrayInitializerNode(Symbol s, VariableInitializerNode varInitHead) {
        super(s);
        this.varInitHead = varInitHead;
    }

    public ArrayInitializerNode(Symbol s, VariableInitializerNode varInitHead,
            boolean hasEndComma) {
        super(s);
        this.varInitHead = varInitHead;
        this.hasEndComma = hasEndComma;
    }

    public ArrayInitializerNode(Symbol s, VariableInitializerNode varInitHead,
            LinkedList<VariableInitializerNode> vList) {
        super(s);
        this.varInitHead = varInitHead;
        this.vList = vList;
    }

    public ArrayInitializerNode(Symbol s, VariableInitializerNode varInitHead,
            LinkedList<VariableInitializerNode> vList,
            boolean hasEndComma) {
        super(s);
        this.varInitHead = varInitHead;
        this.vList = vList;
        this.hasEndComma = hasEndComma;
    }

    public boolean hasEndComma() {
        return this.hasEndComma;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.varInitHead, v);
        checkNull(this.vList, v);
        visitor.end(this);
    }
}
