/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import java.util.LinkedList;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class CatchClauseNode extends SyntaxNode {

    private LinkedList<VariableModifierNode> variableModList = null;
    private CatchTypeNode catchType;
    private String identifier;
    private BlockNode block;

    public CatchClauseNode(Symbol s, LinkedList<VariableModifierNode> variableModList,
            CatchTypeNode catchType, String identifier,
            BlockNode block) {
        super(s);
        this.variableModList = variableModList;
        this.catchType = catchType;
        this.identifier = identifier;
        this.block = block;
    }

    public CatchClauseNode(Symbol s, CatchTypeNode catchType, String identifier,
            BlockNode block) {
        super(s);
        this.catchType = catchType;
        this.identifier = identifier;
        this.block = block;
    }
    /**
     * 
     * @return identifier from catch(E identifier) 
     */
    public String getIdentifier() {
        return this.identifier;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.variableModList, v);
        checkNull(this.catchType, v);
        checkNull(this.block, v);
        visitor.end(this);
    }
}
