/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import java.util.ArrayList;
import lexer.Symbol;
import exceptions.CompilerException;
import java.util.List;

/**
 *
 * @author Michael Burzan
 */
public class CompilationUnitNode extends SyntaxNode {

    private CompilationUnitHelperNode compilationUnitHelperNode;
    private List<ImportDeclarationNode> importDeclarationNodeList;
    private TypeDeclarationNode typeDeclarationNode;
    private TjTypeDefNode tjTypeDef;
    private boolean isTjTypeDef = false;

    public CompilationUnitNode(Symbol s, CompilationUnitHelperNode c,
            List<ImportDeclarationNode> i,
            TypeDeclarationNode t) {
        super(s);
        this.compilationUnitHelperNode = c;
        this.importDeclarationNodeList = i;
        this.typeDeclarationNode = t;
    }

    public CompilationUnitNode(Symbol s, CompilationUnitHelperNode helperNode, ArrayList<ImportDeclarationNode> importList, TjTypeDefNode tjType) {
        super(s);
        this.compilationUnitHelperNode = helperNode;
        this.importDeclarationNodeList = importList;
        this.tjTypeDef = tjType;
        this.isTjTypeDef = true;
    }
    public boolean isTjTypeDef(){
        return this.isTjTypeDef;
    }
    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);

        visitor.visit(this);
        checkNull(compilationUnitHelperNode, visitor);
        checkNull(importDeclarationNodeList, visitor);
        checkNull(typeDeclarationNode, visitor);
        checkNull(tjTypeDef, visitor);
        visitor.end(this);
    }

    
}
