/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class Et1Node extends SyntaxNode {

    private final Expression3Node exp3;
    private final Expression2RestNode exp2Rest;
    private final Expression1RestNode exp1Rest;
    private final AssignmentOperatorNode assignOp;
    private final Expression1Node exp1;
    private final Et1Node et1;

    public Et1Node(Symbol s, Expression3Node exp3, Expression2RestNode exp2Rest,
            Expression1RestNode exp1Rest, AssignmentOperatorNode assignOp,
            Expression1Node exp1, Et1Node et1) {
        super(s);
        this.exp3 = exp3;
        this.exp2Rest = exp2Rest;
        this.exp1Rest = exp1Rest;
        this.assignOp = assignOp;
        this.exp1 = exp1;
        this.et1 = et1;
    }

    public Et1Node() {
        this.exp3 = null;
        this.exp2Rest = null;
        this.exp1Rest = null;
        this.assignOp = null;
        this.exp1 = null;
        this.et1 = null;
    }

    boolean isEmpty() {
        if (this.exp3 == null && this.exp2Rest == null && this.exp1Rest == null
                && this.assignOp == null && this.exp1 == null && this.et1 == null) {
            return true;
        }
        return false;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.exp3, v);
        checkNull(this.exp2Rest, v);
        checkNull(this.exp1Rest, v);
        checkNull(this.assignOp, v);
        checkNull(this.exp1, v);
        checkNull(this.et1, v);
        visitor.end(this);
    }
}
