/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class Expression1Node extends SyntaxNode {

    private Expression2Node expression2;
    private Expression1RestNode expression1Rest = null;

    public Expression1Node(Symbol s, Expression2Node expression2) {
        super(s);
        this.expression2 = expression2;
    }

    public Expression1Node(Symbol s, Expression2Node expression2,
            Expression1RestNode expression1Rest) {
        super(s);
        this.expression2 = expression2;
        this.expression1Rest = expression1Rest;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.expression2, v);
        checkNull(this.expression1Rest, v);
        visitor.end(this);
    }
}
