/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class Expression2Node extends SyntaxNode {

    private Expression3Node expression3;
    private Expression2RestNode expression2Rest = null;

    public Expression2Node(Symbol s, Expression3Node expression3) {
        super(s);
        this.expression3 = expression3;
    }

    public Expression2Node(Symbol s, Expression3Node expression3,
            Expression2RestNode expression2Rest) {
        super(s);
        this.expression3 = expression3;
        this.expression2Rest = expression2Rest;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.expression3, v);
        checkNull(this.expression2Rest, v);
        visitor.end(this);
    }
}
