/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import java.util.LinkedList;
import java.util.List;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class Expression2RestNode extends SyntaxNode {

    public static class InfixOpExpression3Node extends SyntaxNode {

        private InfixOpNode infixOp;
        private Expression3Node expression3;

        public InfixOpExpression3Node(Symbol s, InfixOpNode infixOp, Expression3Node expression3) {
            super(s);
            this.infixOp = infixOp;
            this.expression3 = expression3;
        }

        @Override
        public void accept(Visitor visitor) throws CompilerException {
            infixOp.accept(visitor);
            expression3.accept(visitor);
        }
    }

    public boolean isInfix() {
        return type == null ? true : false;
    }
    private LinkedList<InfixOpExpression3Node> infixExpList = null;
    private TypeNode type = null;

    public List<InfixOpExpression3Node> getInfixList() {
        return this.infixExpList;
    }

    public Expression2RestNode(Symbol s, LinkedList<InfixOpExpression3Node> infixExpList) {
        super(s);
        this.infixExpList = infixExpList;
    }

    public Expression2RestNode(Symbol s, TypeNode type) {
        super(s);
        this.type = type;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.type, v);
        checkNull(this.infixExpList, v);
        visitor.end(this);
    }
}
