/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import java.util.LinkedList;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class ForVarControlNode extends SyntaxNode {

    private LinkedList<VariableModifierNode> varModList;
    private TypeNode type;
    private VariableDeclaratorIdNode varDecId;
    private ForVarControlRestNode forVarControlRest;

    public ForVarControlNode(Symbol s, LinkedList<VariableModifierNode> varModList,
            TypeNode type, VariableDeclaratorIdNode varDecId,
            ForVarControlRestNode forVarControlRest) {
        super(s);
        this.varModList = varModList;
        this.type = type;
        this.varDecId = varDecId;
        this.forVarControlRest = forVarControlRest;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.varModList, v);
        checkNull(this.type, v);
        checkNull(this.varDecId, v);
        checkNull(this.forVarControlRest, v);
        visitor.end(this);
    }
}
