/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import java.util.LinkedList;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class ForVariableDeclaratorsRestNode extends SyntaxNode {

    private VariableInitializerNode varInit = null;
    private LinkedList<VariableDeclaratorNode> varDecList;

    public ForVariableDeclaratorsRestNode(Symbol s) {
        super(s);
    }

    public ForVariableDeclaratorsRestNode(Symbol s, VariableInitializerNode varInit) {
        super(s);
        this.varInit = varInit;
    }

    public ForVariableDeclaratorsRestNode(Symbol s, VariableInitializerNode varInit,
            LinkedList<VariableDeclaratorNode> varDecList) {
        super(s);
        this.varInit = varInit;
        this.varDecList = varDecList;
    }

    public ForVariableDeclaratorsRestNode(Symbol s, LinkedList<VariableDeclaratorNode> varDecList) {
        super(s);
        this.varDecList = varDecList;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.varInit, v);
        checkNull(this.varDecList, v);
        visitor.end(this);
    }
}
