/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class FormalParameterDeclsRestNode extends SyntaxNode {

    private VariableDeclaratorIdNode varDeclId = null;
    private FormalParameterDeclsNode formalParameterDecls = null;
    private boolean hasTriplePoint = false;

    public FormalParameterDeclsRestNode(Symbol s, VariableDeclaratorIdNode varDeclId) {
        super(s);
        this.varDeclId = varDeclId;
    }

    public FormalParameterDeclsRestNode(Symbol s, VariableDeclaratorIdNode varDeclId,
            FormalParameterDeclsNode formalParameterDecls) {
        super(s);
        this.varDeclId = varDeclId;
        this.formalParameterDecls = formalParameterDecls;
    }

    public FormalParameterDeclsRestNode(Symbol s, boolean hasTriplePoint, VariableDeclaratorIdNode varDeclId) {
        super(s);
        this.hasTriplePoint = hasTriplePoint;
        this.varDeclId = varDeclId;
    }

    public boolean hasTriplePoint() {
        return this.hasTriplePoint;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.varDeclId, v);
        checkNull(this.formalParameterDecls, v);
        visitor.end(this);
    }
}
