/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class InterfaceMethodDeclaratorRestNode extends SyntaxNode {

    private FormalParametersNode formalParameters;
    private int edgesClampsCnt;
    private QualifiedIdentifierListNode qList = null;

    public InterfaceMethodDeclaratorRestNode(Symbol s, FormalParametersNode formalParameters,
            int edgesClampsCnt) {
        super(s);
        this.formalParameters = formalParameters;
        this.edgesClampsCnt = edgesClampsCnt;
    }

    public InterfaceMethodDeclaratorRestNode(Symbol s, FormalParametersNode formalParameters,
            int edgesClampsCnt,
            QualifiedIdentifierListNode qList) {
        super(s);
        this.formalParameters = formalParameters;
        this.edgesClampsCnt = edgesClampsCnt;
        this.qList = qList;
    }

    public int getDim() {
        return this.edgesClampsCnt;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.formalParameters, v);
        checkNull(this.qList, v);
        visitor.end(this);
    }
}
