/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import java.util.ArrayList;
import lexer.Symbol;
import exceptions.CompilerException;
import java.util.List;

/**
 *
 * @author Michael Burzan
 */
public class QualifiedIdentifierListNode extends SyntaxNode {

    private QualifiedIdentifierNode qId;
    private ArrayList<QualifiedIdentifierNode> list;
    private List<String> qualifiedIdentifierList;

    public List<String> getQualifiedIdentifierList() {
        return qualifiedIdentifierList;
    }

    public QualifiedIdentifierListNode(Symbol s, QualifiedIdentifierNode q, ArrayList<QualifiedIdentifierNode> list) {
        super(s);
        this.qId = q;
        this.list = list;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.qId, v);
        checkNull(this.list, v);
        visitor.end(this);
    }

    public void setQualifiedIndentifierList(List<String> qualifiedIdentifiers) {
        this.qualifiedIdentifierList = qualifiedIdentifiers;
    }
}
