/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import java.util.ArrayList;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class ReferenceTypeNode extends SyntaxNode {

    private String typeName;
    private TypeArgumentsNode typeArguments = null;
    private ArrayList<DotIdentifierTypeArgumentsHelperNode> dotIdentfierTypeArgumenstList;

    public ReferenceTypeNode(Symbol s, String typeName, TypeArgumentsNode typeArguments,
            ArrayList<DotIdentifierTypeArgumentsHelperNode> dotIdentifierTypeArgumentList) {
        super(s);
        this.typeName = typeName;
        this.typeArguments = typeArguments;
        this.dotIdentfierTypeArgumenstList = dotIdentifierTypeArgumentList;
    }

    public String getName() {
        return this.typeName;
    }

    public TypeArgumentsNode getTypeArguments() {
        return typeArguments;
    }

    public ArrayList<DotIdentifierTypeArgumentsHelperNode> getDotIdentfierTypeArgumenstList() {
        return dotIdentfierTypeArgumenstList;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.typeArguments, v);
        checkNull(this.dotIdentfierTypeArgumenstList, v);
        visitor.end(this);
    }
}
