/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import java.util.ArrayList;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class TjTypeDefBodyDeclarationNode extends SyntaxNode {

    private final boolean isSemicolon;
    private final ArrayList<ModifierNode> modsList;
    private final TjTypeDefMemberDeclNode tjTypeDefMemberDecl;

    public TjTypeDefBodyDeclarationNode(Symbol s, boolean isSemicolon) {
        super(s);
        this.isSemicolon = isSemicolon;
        this.modsList = null;
        this.tjTypeDefMemberDecl = null;
    }

    public TjTypeDefBodyDeclarationNode(Symbol s, ArrayList<ModifierNode> modsList,
            TjTypeDefMemberDeclNode tjTypeDefMemberDecl) {
        super(s);
        this.isSemicolon = false;
        this.modsList = modsList;
        this.tjTypeDefMemberDecl = tjTypeDefMemberDecl;
    }

    public boolean hasSemicolon() {
        return isSemicolon;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.modsList, v);
        checkNull(this.tjTypeDefMemberDecl, v);
        visitor.end(this);
    }
}
