/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import lexer.Symbol;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public class TypeArgumentNode extends SyntaxNode {

    private TypeNode type;
    private boolean hasQuestionMark = false;
    private boolean extendsOf = false;
    private boolean superOf = false;

    public TypeArgumentNode(Symbol s, TypeNode Type) {
        super(s);
        this.type = Type;
    }

    public TypeArgumentNode(Symbol s, boolean hasQuestionMark,
            boolean extendsOf,
            boolean superOf,
            TypeNode type) {
        super(s);
        this.type = type;
        this.hasQuestionMark = hasQuestionMark;
        this.extendsOf = extendsOf;
        this.superOf = superOf;

    }

    public boolean hasQuestionMark() {
        return this.hasQuestionMark;
    }

    public boolean hasExtendsOf() {
        return this.extendsOf;
    }

    public boolean hasSuperOf() {
        return this.superOf;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.type, v);
        visitor.end(this);
    }
}
