/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import codegeneration.Visitor;
import java.util.ArrayList;
import lexer.Symbol;
import exceptions.CompilerException;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
public class TypeParametersNode extends SyntaxNode {

    private TypeParameterNode typeParameter;
    private ArrayList<TypeParameterNode> typeParameterList;
    private List<Type.TypeParamType> generic;

    public TypeParametersNode(Symbol s, TypeParameterNode typeParameter,
            ArrayList<TypeParameterNode> typeParameterList) {
        super(s);
        this.typeParameter = typeParameter;
        this.typeParameterList = typeParameterList;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.typeParameter, v);
        checkNull(this.typeParameterList, v);
        visitor.end(this);
    }

    public void setGeneric(List<Type.TypeParamType> typeParams) {
        this.generic = typeParams;
    }
    public  List<Type.TypeParamType> getGeneric(){
        return this.generic;
    }
}
