/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package abstractsyntaxtree;

import exceptions.CompilerException;
import lexer.Symbol;
import codegeneration.Visitor;

/**
 *
 * @author Michael Burzan
 */
public class VoidMethodeDeclaratorRestHelperNode extends SyntaxNode {

    private String ident;
    private VoidMethodeDeclaratorRestNode voidMethodeDeclRest;

    public VoidMethodeDeclaratorRestHelperNode(Symbol s, String ident,
            VoidMethodeDeclaratorRestNode voidMethodeDeclRest) {
        super(s);
        this.ident = ident;
        this.voidMethodeDeclRest = voidMethodeDeclRest;
    }

    public String getMethodName() {
        return this.ident;
    }

    @Override
    public void accept(Visitor visitor) throws CompilerException {
        visitor.begin(this);
        Visitor v = visitor.visit(this);
        checkNull(this.voidMethodeDeclRest, v);
        visitor.end(this);
    }
}
