/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.abstractvisitors;

import abstractsyntaxtree.ClassDeclarationNode;
import abstractsyntaxtree.InterfaceDeclarationNode;
import abstractsyntaxtree.ModifierNode;
import codegeneration.Visitor;
import teajay.bytecode.ClassFile;

/**
 *
 * @author Michael Burzan
 */
public abstract class AbstractClassOrInterfaceDeclarationVisitor<T> extends Visitor {

    public abstract void begin(ModifierNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ModifierNode node) throws exceptions.CompilerException;

    public abstract void end(ModifierNode node) throws exceptions.CompilerException;

    public abstract void begin(ClassDeclarationNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ClassDeclarationNode node) throws exceptions.CompilerException;

    public abstract void end(ClassDeclarationNode node) throws exceptions.CompilerException;

    public abstract void begin(InterfaceDeclarationNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(InterfaceDeclarationNode node) throws exceptions.CompilerException;

    public abstract void end(InterfaceDeclarationNode node) throws exceptions.CompilerException;

    public abstract T getClassFileContainer() throws exceptions.CompilerException;
}
