/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.abstractvisitors;

import abstractsyntaxtree.ArrayCreatorRestNode;
import abstractsyntaxtree.ClassCreatorRestNode;
import abstractsyntaxtree.CreatedNameNode;
import abstractsyntaxtree.NonWildcardTypeArgumentsNode;
import codegeneration.Visitor;

/**
 *
 * @author Michael Burzan
 */
public abstract class AbstractCreatorVisitor extends Visitor {

    public abstract void begin(NonWildcardTypeArgumentsNode node) throws exceptions.CompilerException;

    public abstract void begin(CreatedNameNode node) throws exceptions.CompilerException;

    public abstract void begin(ClassCreatorRestNode node) throws exceptions.CompilerException;

    public abstract void begin(ArrayCreatorRestNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(NonWildcardTypeArgumentsNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(CreatedNameNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ClassCreatorRestNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ArrayCreatorRestNode node) throws exceptions.CompilerException;

    public abstract void end(NonWildcardTypeArgumentsNode node) throws exceptions.CompilerException;

    public abstract void end(CreatedNameNode node) throws exceptions.CompilerException;

    public abstract void end(ClassCreatorRestNode node) throws exceptions.CompilerException;

    public abstract void end(ArrayCreatorRestNode node) throws exceptions.CompilerException;
}
