/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.abstractvisitors;

import abstractsyntaxtree.ExpressionNode;
import abstractsyntaxtree.ReferenceTypeNode;
import abstractsyntaxtree.VariableDeclaratorIdNode;
import abstractsyntaxtree.VariableModifierNode;
import codegeneration.Visitor;

/**
 *
 * @author Michael Burzan
 */
public abstract class AbstractResourceVisitor extends Visitor {

    public abstract void begin(VariableModifierNode node) throws exceptions.CompilerException;

    public abstract void begin(ReferenceTypeNode node) throws exceptions.CompilerException;

    public abstract void begin(VariableDeclaratorIdNode node) throws exceptions.CompilerException;

    public abstract void begin(ExpressionNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(VariableModifierNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ReferenceTypeNode node) throws exceptions.CompilerException;

    public abstract void visit(VariableDeclaratorIdNode node) throws exceptions.CompilerException;

    public abstract Visitor visit(ExpressionNode node) throws exceptions.CompilerException;

    public abstract void end(VariableModifierNode node) throws exceptions.CompilerException;

    public abstract void end(ReferenceTypeNode node) throws exceptions.CompilerException;

    public abstract void end(VariableDeclaratorIdNode node) throws exceptions.CompilerException;

    public abstract void end(ExpressionNode node) throws exceptions.CompilerException;
}
