/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor;

import codegeneration.javavisitor.classes.ClassDeclarationVisitor;
import codegeneration.abstractvisitors.AbstractClassOrInterfaceDeclarationVisitor;
import codegeneration.abstractvisitors.AbstractClassDeclarationVisitor;
import abstractsyntaxtree.ClassDeclarationNode;
import abstractsyntaxtree.InterfaceDeclarationNode;
import abstractsyntaxtree.ModifierNode;
import codegeneration.Visitor;
import exceptions.CompilerException;
import java.util.LinkedList;
import java.util.List;
import teajay.bytecode.ClassFile;

/**
 *
 * @author Michael Burzan
 */
public class ClassOrInterfaceDeclarationVisitor extends AbstractClassOrInterfaceDeclarationVisitor<ClassFile> {

    private List<ModifierNode.Modifier> modList = new LinkedList<>();
    private AbstractClassDeclarationVisitor<ClassFile> classDeclarationVisitor;
    private final String packageName;
    private ClassFile classFile;

    public ClassOrInterfaceDeclarationVisitor(String packageName) {
        this.packageName = packageName;
    }

    @Override
    public void begin(ModifierNode node) {
    }

    @Override
    public Visitor visit(ModifierNode node) {
        modList.add(node.getModifier());
        return this;
    }

    @Override
    public void end(ModifierNode node) {
    }

    @Override
    public void begin(ClassDeclarationNode node) {
    }

    @Override
    public Visitor visit(ClassDeclarationNode node) {
        return this.classDeclarationVisitor = new ClassDeclarationVisitor(modList, packageName);
    }

    @Override
    public void end(ClassDeclarationNode node) throws CompilerException {
        this.classFile = this.classDeclarationVisitor.getClassContainer();
    }

    @Override
    public void begin(InterfaceDeclarationNode node) {
    }

    @Override
    public Visitor visit(InterfaceDeclarationNode node) {
        return null;
    }

    @Override
    public void end(InterfaceDeclarationNode node) {
    }

    @Override
    public ClassFile getClassFileContainer() {
        return this.classFile;
    }
}
