/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor;

import abstractsyntaxtree.TypeNode;
import abstractsyntaxtree.VariableDeclaratorsNode;
import abstractsyntaxtree.VariableModifierNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractLocalVariableDeclarationsStatementVisitor;
import teajay.bytecode.ClassFile;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author cefour
 */
public class LocalVariableDeclarationsStatementVisitor extends AbstractLocalVariableDeclarationsStatementVisitor {

    private final MethodInfo info;
    private final ClassFile classFile;
    private String typeName;

    public LocalVariableDeclarationsStatementVisitor(ClassFile classFile, MethodInfo info) {
        this.classFile = classFile;
        this.info = info;
    }
    private TypeVisitor typeVisitor;

    @Override
    public void begin(VariableModifierNode node) {
    }

    @Override
    public void begin(TypeNode node) {
    }

    @Override
    public void begin(VariableDeclaratorsNode node) {
    }

    @Override
    public Visitor visit(VariableModifierNode node) {
        return null;
    }

    @Override
    public Visitor visit(TypeNode node) {
        this.typeVisitor = new TypeVisitor();
        return this.typeVisitor;
    }

    @Override
    public Visitor visit(VariableDeclaratorsNode node) {
        return new VariableDeclaratorsVisitor(this.classFile, this.info, this.typeName);
    }

    @Override
    public void end(VariableModifierNode node) {
    }

    @Override
    public void end(TypeNode node) {
        this.typeName = this.typeVisitor.getTypeName();
    }

    @Override
    public void end(VariableDeclaratorsNode node) {
    }
}
