/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor;

import codegeneration.abstractvisitors.AbstractReferenceTypeVisitor;
import abstractsyntaxtree.DotIdentifierTypeArgumentsHelperNode;
import abstractsyntaxtree.TypeArgumentsNode;
import codegeneration.Visitor;
import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author cefour
 */
public class ReferenceTypeVisitor extends AbstractReferenceTypeVisitor {

    private List<String> identifierList = new LinkedList<>();

    public ReferenceTypeVisitor() {
    }

    @Override
    public void begin(TypeArgumentsNode node) {
    }

    @Override
    public Visitor visit(TypeArgumentsNode node) {

        return new TypeArgumentsVisitor();
    }

    @Override
    public void end(TypeArgumentsNode node) {
    }

    @Override
    public void begin(DotIdentifierTypeArgumentsHelperNode node) {
        this.identifierList.add(node.getIdentifier());
    }

    @Override
    public Visitor visit(DotIdentifierTypeArgumentsHelperNode node) {
        return this;
    }

    @Override
    public void end(DotIdentifierTypeArgumentsHelperNode node) {
    }

    public List<String> getList() {
        return this.identifierList;
    }
}
