/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor;

import abstractsyntaxtree.VariableDeclaratorNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractVariableDeclaratorsVisitor;
import teajay.bytecode.ClassFile;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author cefour
 */
public class VariableDeclaratorsVisitor extends AbstractVariableDeclaratorsVisitor {

    private final MethodInfo info;
    private final ClassFile classFile;
    private final String typeName;

    public VariableDeclaratorsVisitor(ClassFile classFile, MethodInfo info, String typeName) {
        this.classFile = classFile;
        this.info = info;
        this.typeName = typeName;
    }

    @Override
    public void begin(VariableDeclaratorNode node) {
    }

    @Override
    public Visitor visit(VariableDeclaratorNode node) {
        return new VariableDeclaratorVisitor(this.classFile, this.info, node.getName(), typeName);
    }

    @Override
    public void end(VariableDeclaratorNode node) {
    }
}
