/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.compilationunit;

import abstractsyntaxtree.CompilationUnitHelperNode;
import abstractsyntaxtree.CompilationUnitNode;
import abstractsyntaxtree.ImportDeclarationNode;
import abstractsyntaxtree.TjTypeDefNode;
import abstractsyntaxtree.TypeDeclarationNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractCompilationUnitHelperVisitor;
import codegeneration.abstractvisitors.AbstractCompilationUnitVisitor;
import codegeneration.abstractvisitors.AbstractImportDeclarationVisitor;
import codegeneration.abstractvisitors.AbstractTypeDeclarationVisitor;
import exceptions.CompilerException;

/**
 *
 * @author cefour
 */
public class CompilationUnitVisitor extends AbstractCompilationUnitVisitor {

    private AbstractCompilationUnitHelperVisitor compUnitHelperVisitor;
    private AbstractImportDeclarationVisitor importVisitor;
    private AbstractTypeDeclarationVisitor typeVisitor;

    /*Visit compilation unit node*/
    @Override
    public void begin(CompilationUnitNode node) throws CompilerException {
    }

    @Override
    public void visit(CompilationUnitNode visitor) throws CompilerException {
    }

    @Override
    public void end(CompilationUnitNode node) throws CompilerException {
    }
    /*Visit type declaratioin node */

    @Override
    public void begin(TypeDeclarationNode node) throws CompilerException {
        this.typeVisitor = new TypeDeclarationVisitor(this.compUnitHelperVisitor.getPackageName());
    }

    @Override
    public Visitor visit(TypeDeclarationNode node) throws CompilerException {
        if (!node.isEmpty()) {
            return this.typeVisitor;
        }
        return null;
    }

    @Override
    public void end(TypeDeclarationNode node) throws CompilerException {
    }
    /*visit import declartion node */

    @Override
    public void begin(ImportDeclarationNode node) throws CompilerException {

        this.importVisitor = new ImportDeclarationVisitor(node.hasWildcard(), node.isStatic());
    }

    @Override
    public Visitor visit(ImportDeclarationNode node) throws CompilerException {
        return this.importVisitor;
    }

    @Override
    public void end(ImportDeclarationNode node) throws CompilerException {
    }

    /* 
     * Visit compilation unit helper node
     * Organize packages 
     */
    @Override
    public void begin(CompilationUnitHelperNode node) throws CompilerException {
        this.compUnitHelperVisitor = new CompilationUnitHelperVisitor();
    }

    @Override
    public Visitor visit(CompilationUnitHelperNode node) throws CompilerException {
        return this.compUnitHelperVisitor;
    }

    @Override
    public void end(CompilationUnitHelperNode node) throws CompilerException {
    }

    @Override
    public void begin(TjTypeDefNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(TjTypeDefNode node) throws CompilerException {
        return null;
    }

    @Override
    public void end(TjTypeDefNode node) throws CompilerException {
    }
}
