/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.enums;

import abstractsyntaxtree.EnumBodyNode;
import abstractsyntaxtree.TypeListNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractEnumDeclarationVisitor;
import java.util.List;
import teajay.bytecode.ClassFile;

/**
 *
 * @author cefour
 */
public class EnumDeclarationVisitor extends AbstractEnumDeclarationVisitor {

    private final ClassFile classFile;
    private EnumBodyVisitor enumBodyVisitor;

    public EnumDeclarationVisitor(ClassFile classFile) {
        this.classFile = classFile;
    }

    @Override
    public void begin(TypeListNode node) {
    }

    @Override
    public void begin(EnumBodyNode node) {
    }

    @Override
    public Visitor visit(TypeListNode node) {
        return this;
    }

    @Override
    public Visitor visit(EnumBodyNode node) {
        this.enumBodyVisitor = new EnumBodyVisitor(classFile);
        return enumBodyVisitor;
    }

    @Override
    public void end(TypeListNode node) {
    }

    @Override
    public void end(EnumBodyNode node) {
    }

    public List<String> getContainer() {
        return enumBodyVisitor.getContainer();
    }
}
