/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package codegeneration.javavisitor.expression;

import abstractsyntaxtree.ArgumentsNode;
import abstractsyntaxtree.BasicTypeNode;
import abstractsyntaxtree.ClosureCreatorNode;
import abstractsyntaxtree.CreatorNode;
import abstractsyntaxtree.ExplicitGenericInvocationSuffixNode;
import abstractsyntaxtree.ExpressionNode;
import abstractsyntaxtree.IdentifierSuffixNode;
import abstractsyntaxtree.LiteralNode;
import abstractsyntaxtree.NonWildcardTypeArgumentsNode;
import abstractsyntaxtree.ParExpressionNode;
import abstractsyntaxtree.SuperSuffixNode;
import abstractsyntaxtree.TypeNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractPrimaryVisitor;
import codegeneration.javavisitor.IdentifierSuffixVisitor;
import java.util.List;
import teajay.bytecode.ClassFile;
import teajay.bytecode.methods.MethodInfo;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author cefour
 */
public class PrimaryVisitor extends AbstractPrimaryVisitor {

    private final ClassFile classFile;
    private final MethodInfo info;
    private final String identifier;
    private final List<String> identifierList;
    private LiteralNode.LiteralType literalType;
    private String literalValue;

    public PrimaryVisitor(ClassFile classFile, MethodInfo info) {
        this.classFile = classFile;
        this.info = info;
        this.identifier = null;
        this.identifierList = null;
    }

    public PrimaryVisitor(ClassFile classFile, MethodInfo info, String identifier, List<String> identifierList) {
        this.classFile = classFile;
        this.info = info;
        this.identifier = identifier;
        this.identifierList = identifierList;
    }

    public LiteralNode.LiteralType getLiteralType() {
        return this.literalType;
    }

    public String getLiteralValue() {
        return this.literalValue;
    }

    @Override
    public void begin(LiteralNode node) {
        this.literalType = node.getLiteralType();
        this.literalValue = node.getLiteralValue();
    }

    @Override
    public void begin(ParExpressionNode node) {
    }

    @Override
    public void begin(ArgumentsNode node) {
    }

    @Override
    public void begin(SuperSuffixNode node) {
    }

    @Override
    public void begin(CreatorNode node) {
    }

    @Override
    public void begin(NonWildcardTypeArgumentsNode node) {
    }

    @Override
    public void begin(ExplicitGenericInvocationSuffixNode node) {
    }

    @Override
    public void begin(IdentifierSuffixNode node) {
    }

    @Override
    public void begin(TypeNode node) {
    }

    public void begin(ClosureCreatorNode node) {
    }

    @Override
    public void begin(BasicTypeNode node) {
    }

    @Override
    public void visit(LiteralNode node) {
    }

    @Override
    public Visitor visit(ParExpressionNode node) {
        return null;
    }

    @Override
    public Visitor visit(ArgumentsNode node) {
        return null;
    }

    @Override
    public Visitor visit(SuperSuffixNode node) {
        return null;
    }

    @Override
    public Visitor visit(CreatorNode node) {
        return null;
    }

    @Override
    public Visitor visit(NonWildcardTypeArgumentsNode node) {
        return null;
    }

    @Override
    public Visitor visit(ExplicitGenericInvocationSuffixNode node) {
        return null;
    }

    @Override
    public Visitor visit(IdentifierSuffixNode node) {
        return new IdentifierSuffixVisitor(this.classFile, this.info, this.identifier, this.identifierList);
    }

    @Override
    public void visit(BasicTypeNode node) {
    }

    @Override
    public Visitor visit(TypeNode node) {
        return null;
    }

    public Visitor visit(ClosureCreatorNode node) {
        return null;
    }

    @Override
    public void end(LiteralNode node) {
    }

    @Override
    public void end(ParExpressionNode node) {
    }

    @Override
    public void end(ArgumentsNode node) {
    }

    @Override
    public void end(SuperSuffixNode node) {
    }

    @Override
    public void end(CreatorNode node) {
    }

    @Override
    public void end(NonWildcardTypeArgumentsNode node) {
    }

    @Override
    public void end(ExplicitGenericInvocationSuffixNode node) {
    }

    @Override
    public void end(IdentifierSuffixNode node) {
    }

    @Override
    public void end(BasicTypeNode node) {
    }

    @Override
    public void end(TypeNode node) {
    }

    public void end(ClosureCreatorNode node) {
    }

    @Override
    public void begin(ExpressionNode node) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public Visitor visit(ExpressionNode node) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void end(ExpressionNode node) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
}
