/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.expression.expressiontransform;

import codegeneration.environment.ExpressionEnvironment;
import abstractsyntaxtree.ArrayCreatorRestNode;
import abstractsyntaxtree.ClassCreatorRestNode;
import abstractsyntaxtree.CreatedNameNode;
import abstractsyntaxtree.NonWildcardTypeArgumentsNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractCreatorVisitor;
import codegeneration.instruction.InstructionCreator;
import exceptions.CompilerException;
import symbol.LocalEntry;
import symbol.SymbolFacade;
import teajay.bytecode.attributes.code.AStore;
import teajay.bytecode.attributes.code.Dup;
import teajay.bytecode.attributes.code.InvokeSpecial;
import teajay.bytecode.attributes.code.JVMInstructionList;
import teajay.bytecode.attributes.code.New;
import teajay.bytecode.cpool.ClassInfo;
import teajay.bytecode.cpool.MethodRefInfo;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 *
 * @author cefour
 */
class CreatorVisitor extends AbstractCreatorVisitor {

    private final ExpressionEnvironment env;

    public CreatorVisitor(ExpressionEnvironment env) {
        this.env = env;
    }

    @Override
    public void begin(NonWildcardTypeArgumentsNode node) {
    }

    @Override
    public void begin(CreatedNameNode node) {
        String ident = node.getIdentifier();
        ident = null;//SymbolFacade.instance().getFullQualifiedId(ident);
        try {
            if (ident == null) {
                throw new CompilerException("new expected type", node.getSymbol());
            }

            //JVMInstructionList instructionList = env.info.getCode().getInstructionList();
            // System.err.println(new New(new ClassInfo(ident)).toString());
            //System.err.println("Dup");
            env.insertCode(new New(new ClassInfo(ident)));
            env.insertCode(new Dup());

            env.setResultType(ident);
            env.setResultType(ident);


        } catch (ByteCodeException ex) {
            ex.printStackTrace(System.err);
        } catch (CompilerException ex) {
            ex.printStackTrace(System.err);
            System.exit(-1);
        }

    }

    @Override
    public void begin(ClassCreatorRestNode node) {
    }

    @Override
    public void begin(ArrayCreatorRestNode node) {
    }

    @Override
    public Visitor visit(NonWildcardTypeArgumentsNode node) {
        return null;
    }

    @Override
    public Visitor visit(CreatedNameNode node) {
        return null;
    }

    @Override
    public Visitor visit(ClassCreatorRestNode node) {
        return new ClassCreaterRestVisitor(env);
    }

    @Override
    public Visitor visit(ArrayCreatorRestNode node) {
        return null;
    }

    @Override
    public void end(NonWildcardTypeArgumentsNode node) {
    }

    @Override
    public void end(CreatedNameNode node) {
    }

    @Override
    public void end(ClassCreatorRestNode node) {
    }

    @Override
    public void end(ArrayCreatorRestNode node) {
    }
}
