/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.expression.expressiontransform;

import codegeneration.environment.ExpressionEnvironment;
import abstractsyntaxtree.ArgumentsNode;
import abstractsyntaxtree.BasicTypeNode;
import abstractsyntaxtree.ClosureCreatorNode;
import abstractsyntaxtree.CreatorNode;
import abstractsyntaxtree.ExplicitGenericInvocationSuffixNode;
import abstractsyntaxtree.ExpressionNode;
import abstractsyntaxtree.IdentifierSuffixNode;
import static abstractsyntaxtree.IdentifierSuffixNode.SuffixType.ARRAY_EXPRESSION;
import static abstractsyntaxtree.IdentifierSuffixNode.SuffixType.ARRAY_SUFFIX;
import static abstractsyntaxtree.IdentifierSuffixNode.SuffixType.CALL;
import static abstractsyntaxtree.IdentifierSuffixNode.SuffixType.EXPLICIT_GENERIC_INVOCATION;
import static abstractsyntaxtree.IdentifierSuffixNode.SuffixType.INNER_CREATOR;
import static abstractsyntaxtree.IdentifierSuffixNode.SuffixType.NON_WILDCARD_TYPE_ARGUMENTS;
import static abstractsyntaxtree.IdentifierSuffixNode.SuffixType.SUFFIX;
import static abstractsyntaxtree.IdentifierSuffixNode.SuffixType.SUFFIX_CALL;
import abstractsyntaxtree.InfixOpNode;
import abstractsyntaxtree.LiteralNode;
import abstractsyntaxtree.NonWildcardTypeArgumentsNode;
import abstractsyntaxtree.ParExpressionNode;
import abstractsyntaxtree.SuperSuffixNode;
import abstractsyntaxtree.TypeNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractPrimaryVisitor;
import codegeneration.instruction.MethodInvokeCreator;
import codegeneration.javavisitor.TypeVisitor;
import exceptions.CompilerException;
import java.io.IOException;
import java.util.LinkedList;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;
import teajay.bytecode.attributes.code.ALoad;
import teajay.bytecode.attributes.code.CheckCast;
import teajay.bytecode.attributes.code.InvokeStatic;
import teajay.bytecode.attributes.code.JVMInstruction;
import teajay.bytecode.attributes.code.Ldc;
import teajay.bytecode.attributes.code.StackMapFrame;
import teajay.bytecode.cpool.ClassInfo;
import teajay.bytecode.cpool.FieldDescriptor;
import teajay.bytecode.cpool.MethodRefInfo;
import teajay.bytecode.exceptions.ByteCodeException;
import teajay.runtime.exceptions.ResolveException;

/**
 *
 * @author cefour
 */

class PrimaryVisitor extends Visitor{//extends AbstractPrimaryVisitor {
//
//    private final ExpressionEnvironment env;
//    //private ALoad thisCall;
//    //private StackMapFrame frame;
//    private MethodInvokeCreator.CallContext context;
//    private StackMapFrame frame;
//    private JVMInstruction thisCall;
   private TypeVisitor typeVisitor;
   private CheckCast checkCast;
   private String checkCastResult;
//
    public PrimaryVisitor(ExpressionEnvironment env) {
//        this.env = env;
    }
//
//    @Override
//    public void begin(LiteralNode node) {
//        LiteralNode.LiteralType literalType = node.getLiteralType();
//        // JVMInstructionList instructionList = this.env.info.getCode().getInstructionList();
//        String val = node.getLiteralValue();
//        try {
//            switch (literalType) {
//                case BOOLEAN:
//                    break;
//                case INT:
//                case LONG:
//                case FLOAT:
//                case DOUBLE:
//                case CHAR:
//                    this.env.setResultType("teajay/lang/Number");
//                    //env.instructionTypes.add(this.env.resultType);
//                    MethodRefInfo ref = MethodRefInfo.make(new ClassInfo("teajay/lang/Number"), "$valueOf", FieldDescriptor.fromString("teajay/lang/Number"), FieldDescriptor.getString());
//
//                    env.insertCode(new Ldc(val));
//                    env.insertCode(new InvokeStatic(ref));
//                    break;
//                case STRING:
//                    this.env.setResultType("java/lang/String");
//
//                    env.insertCode(new Ldc(val));
//                    break;
//                case NULL:
//                    break;
//                default:
//                    throw new AssertionError(literalType.name());
//
//            }
//        } catch (ByteCodeException ex) {
//            ex.printStackTrace(System.err);
//        }
//    }
//
//    @Override
//    public void begin(TypeNode node) {
//    }
//
//    @Override
//    public void begin(ParExpressionNode node) {
//    }
//
//    @Override
//    public void begin(ArgumentsNode node) {
//    }
//
//    @Override
//    public void begin(SuperSuffixNode node) {
//        try {
//            if (env.getMethod().getName().equals("<init>")) {
//                env.insertCode(new ALoad(0));
//                env.setResultType(env.getClassName());
//            } else {
//                throw new CompilerException("super call is only possible in constructor", node.getSymbol());
//            }
//        } catch (CompilerException | ByteCodeException ex) {
//        }
//    }
//
//    @Override
//    public void begin(CreatorNode node) {
//    }
//
//    @Override
//    public void begin(NonWildcardTypeArgumentsNode node) {
//    }
//
//    @Override
//    public void begin(ExplicitGenericInvocationSuffixNode node) {
//    }
//
//    @Override
//    public void begin(IdentifierSuffixNode node) {
//        try {
//            switch (node.getSuffixType()) {
//                case SUFFIX_CALL:
//                    break;
//                case CALL:
//                    this.context = MethodInvokeCreator.createMethodAccess(env, node.getIdentifier(), node.getIdentifierList(), node);
//                    break;
//                case SUFFIX:
//                    break;
//                case INNER_CREATOR:
//                    break;
//                case EXPLICITE_GENERIC_INVOCATION:
//                    break;
//                case NON_WILDCARD_TYPE_ARGUMENTS:
//                    break;
//                case ARRAY_EXPRESSION:
//                    break;
//                case ARRAY_SUFFIX:
//                    break;
//                default:
//                    throw new AssertionError(node.getSuffixType().name());
//
//            }
//        } catch (ByteCodeException | CompilerException ex) {
//            ex.printStackTrace(System.err);
//            System.exit(-1);
//        } catch (IOException ex) {
//            Logger.getLogger(PrimaryVisitor.class.getName()).log(Level.SEVERE, null, ex);
//        } catch (ResolveException ex) {
//            Logger.getLogger(PrimaryVisitor.class.getName()).log(Level.SEVERE, null, ex);
//        }
//
//        /*try {
//         String ident = node.getIdentifier();
//         int listSize = node.getIdentifierList().size();
//         if (listSize != 0) {
//         LocalEntry entry = SymbolFacade.instance().getLocalTable().getEntry(ident);
//         if (entry != null) { //Is ident a local variable
//         VariableInstructionCreator.createLocalVariableInstruction(env, entry, ident, node.getIdentifierList().subList(0, listSize - 1), node);
//         } else {
//         FieldInfo field = FieldTypeResolver.find(env.getFile(), ident);
//         if (field != null) {
//         VariableInstructionCreator.createFieldInstruction(ident, node.getIdentifierList().subList(0, listSize - 1), env, node);
//         } else {
//         if (listSize > 0) {
//         VariableInstructionCreator.createClassInstruction(ident, node.getIdentifierList().subList(0, listSize - 1), env, node);
//         }
//         }
//         }
//
//         } else { // static call or this call
//         this.thisCall = new ALoad(0);
//         env.insertCode(this.thisCall);
//         this.frame = env.getMethod().getCode().getStackMapTable().getFrame(this.thisCall);
//         env.setResultType(env.getClassName());
//         //env.resultType = env.getClassName();
//         //env.instructionTypes.add(this.env.resultType);
//         }
//
//
//         } catch (ByteCodeException | CompilerException | ResolveException | IOException e) {
//         e.printStackTrace(System.err);
//         System.exit(-1);
//         }*/
//    }
//
//    @Override
//    public void begin(BasicTypeNode node) {
//    }
//
//    @Override
//    public void begin(ClosureCreatorNode node) {
//    }
//
//    @Override
//    public void visit(LiteralNode node) {
//    }
//
//    @Override
//    public Visitor visit(TypeNode node) {
//        return this.typeVisitor = new TypeVisitor();
//    }
//
//    @Override
//    public Visitor visit(ParExpressionNode node) {
//        return new ParExpressioVisitor(env);
//    }
//
//    @Override
//    public Visitor visit(ArgumentsNode node) {
//        return this;
//    }
//
//    @Override
//    public Visitor visit(SuperSuffixNode node) {
//        return new SuperSuffixVisitor(env);
//    }
//
//    @Override
//    public Visitor visit(CreatorNode node) {
//        return new CreatorVisitor(env);
//    }
//
//    @Override
//    public Visitor visit(NonWildcardTypeArgumentsNode node) {
//        return this;
//    }
//
//    @Override
//    public Visitor visit(ExplicitGenericInvocationSuffixNode node) {
//        return this;
//    }
//
//    @Override
//    public Visitor visit(IdentifierSuffixNode node) {
//        return new IdentifierSuffixVisitor(env);
//    }
//
//    @Override
//    public void visit(BasicTypeNode node) {
//    }
//
//    @Override
//    public Visitor visit(ClosureCreatorNode node) {
//        return this;
//    }
//
//    @Override
//    public void end(LiteralNode node) {
//    }
//
//    @Override
    public void end(TypeNode node) {
        String s = this.typeVisitor.getTypeName();
        try {
            this.checkCast = new CheckCast(new ClassInfo(s));
            this.checkCastResult = s;
            //env.insertCode());
            //env.setResultType(s);
        } catch (ByteCodeException ex) {
            Logger.getLogger(PrimaryVisitor.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
//
//    @Override
//    public void end(ParExpressionNode node) {
//    }
//
//    @Override
//    public void end(ArgumentsNode node) {
//    }
//
//    @Override
//    public void end(SuperSuffixNode node) {
//    }
//
//    @Override
//    public void end(CreatorNode node) {
//    }
//
//    @Override
//    public void end(NonWildcardTypeArgumentsNode node) {
//    }
//
//    @Override
//    public void end(ExplicitGenericInvocationSuffixNode node) {
//    }
//
//    @Override
//    public void end(IdentifierSuffixNode node) {
//        try {
//            switch (node.getSuffixType()) {
//                case SUFFIX_CALL:
//                    break;
//                case CALL:
//                    MethodInvokeCreator.createMethodCall(this.context, this.env, node.getIdentifier(), node.getIdentifierList(), node);
//                    break;
//                case SUFFIX:
//                    break;
//                case INNER_CREATOR:
//                    break;
//                case EXPLICITE_GENERIC_INVOCATION:
//                    break;
//                case NON_WILDCARD_TYPE_ARGUMENTS:
//                    break;
//                case ARRAY_EXPRESSION:
//                    break;
//                case ARRAY_SUFFIX:
//                    break;
//                default:
//                    throw new AssertionError(node.getSuffixType().name());
//
//            }
//        } catch (ByteCodeException | CompilerException ex) {
//            ex.printStackTrace(System.err);
//            System.exit(-1);
//        } catch (IOException ex) {
//            Logger.getLogger(PrimaryVisitor.class.getName()).log(Level.SEVERE, null, ex);
//        } catch (ResolveException ex) {
//            Logger.getLogger(PrimaryVisitor.class.getName()).log(Level.SEVERE, null, ex);
//        }
//
//
//        /* if (node.getIdentifierList().size() != 0) {
//         String callName = node.getIdentifierList().get(node.getIdentifierList().size() - 1);
//         try {
//         MethodInfo info = MethodResolver.existMethod(env.getResultType(), callName, env.parametersType.toArray(new String[0]));
//         ClassFileRef find = ClassFinder.instance().find(env.getResultType());
//         MethodRefInfo callInfo;
//         callInfo = MethodRefInfo.make(find.get().getThis(), callName, info.getDescriptor().getReturnType(), info.getDescriptor().getParameters().toArray(new FieldDescriptor[0]));
//         if (info.isStatic()) {
//         env.insertCode(new InvokeStatic(callInfo));
//
//         JVMInstructionList instructionList = this.env.getMethod().getCode().getInstructionList();
//         JVMInstruction successor = instructionList.getSuccessor(thisCall);
//         Set<Label> labelsFor = instructionList.getLabelsFor(thisCall);
//         instructionList.remove(thisCall);
//         if (frame != null) {
//         env.getMethod().getCode().getStackMapTable().addFrame(frame, successor);
//         }
//         if (labelsFor != null) {
//         instructionList.addLabelsFor(successor, labelsFor);
//         }
//
//
//
//         } else {
//         env.insertCode(new InvokeVirtual(callInfo));
//         }
//         env.setResultType(info.getDescriptor().getReturnType().getClassInfo().getClassName());
//         } catch (ByteCodeException ex) {
//         Logger.getLogger(PrimaryVisitor.class.getName()).log(Level.SEVERE, null, ex);
//         } catch (IOException ex) {
//         Logger.getLogger(PrimaryVisitor.class.getName()).log(Level.SEVERE, null, ex);
//         } catch (ResolveException ex) {
//         Logger.getLogger(PrimaryVisitor.class.getName()).log(Level.SEVERE, null, ex);
//         }
//         } else {
//
//         String callName = node.getIdentifier();
//         try {
//
//         MethodInfo info = MethodResolver.existMethod(env.getResultType(), callName, env.parametersType.toArray(new String[0]));
//         if (info == null) {
//         throw new CompilerException("No souch method " + callName + " found", node.getSymbol());
//         }
//         ClassFileRef find = ClassFinder.instance().find(env.getResultType());
//         MethodRefInfo callInfo;
//         callInfo = MethodRefInfo.make(find.get().getThis(), callName, info.getDescriptor().getReturnType(), info.getDescriptor().getParameters().toArray(new FieldDescriptor[0]));
//         if (info.isStatic()) {
//         env.insertCode(new InvokeStatic(callInfo));
//
//         JVMInstructionList instructionList = this.env.getMethod().getCode().getInstructionList();
//         JVMInstruction successor = instructionList.getSuccessor(thisCall);
//         Set<Label> labels = instructionList.getLabelsFor(thisCall);
//    
//         instructionList.remove(thisCall);
//         if (frame != null) {
//         env.getMethod().getCode().getStackMapTable().addFrame(frame, successor);
//         }
//         instructionList.addLabelsFor(successor, labels);
//         } else {
//         env.insertCode(new InvokeVirtual(callInfo));
//         }
//         env.setResultType(info.getDescriptor().getReturnType().getClassInfo().getClassName());
//         } catch (ByteCodeException ex) {
//         Logger.getLogger(PrimaryVisitor.class.getName()).log(Level.SEVERE, null, ex);
//         } catch (IOException ex) {
//         Logger.getLogger(PrimaryVisitor.class.getName()).log(Level.SEVERE, null, ex);
//         } catch (ResolveException ex) {
//         Logger.getLogger(PrimaryVisitor.class.getName()).log(Level.SEVERE, null, ex);
//         } catch (CompilerException ex) {
//         ex.printStackTrace(System.err);
//         System.exit(-1);
//         }
//         }*/
//    }
//
//    @Override
//    public void end(BasicTypeNode node) {
//    }
//
//    @Override
//    public void end(ClosureCreatorNode node) {
//    }
//
//    @Override
//    public void begin(ExpressionNode node) {
//    }
//
//    @Override
//    public Visitor visit(ExpressionNode node) {
//        return new ExpressionVisitor(new ExpressionEnvironment(env.getFile(), env.getMethod()), new LinkedList<InfixOpNode.InfixOps>(), true);
//    }
//
//    @Override
    public void end(ExpressionNode node) {
        //try {
           // env.insertCode(this.checkCast);
        //} catch (ByteCodeException ex) {
          //  Logger.getLogger(PrimaryVisitor.class.getName()).log(Level.SEVERE, null, ex);
        //}
        //env.setResultType(this.checkCastResult);
    }
}
