/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.method;

import abstractsyntaxtree.FormalParameterDeclsNode;
import abstractsyntaxtree.VariableDeclaratorIdNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractFormalParameterDeclsRestVisitor;
import codegeneration.abstractvisitors.AbstractFormalParameterDeclsVisitor;
import codegeneration.abstractvisitors.AbstractTypeVisitor;
import datastructs.Pair;
import java.util.List;
import teajay.bytecode.cpool.FieldDescriptor;
import teajay.bytecode.cpool.MethodDescriptor;

/**
 *
 * @author cefour
 */
public class FormalParameterDeclsRestVisitor extends AbstractFormalParameterDeclsRestVisitor {

    private String varName;
    private final AbstractTypeVisitor typeVisitor;
    private AbstractFormalParameterDeclsVisitor formalParameterDeclsVisitor;
    private final List<Pair<FieldDescriptor, String>> paramList;

    FormalParameterDeclsRestVisitor(AbstractTypeVisitor typeVisitor, List<Pair<FieldDescriptor, String>> paramList) {
        this.typeVisitor = typeVisitor;
        this.paramList = paramList;
    }

    @Override
    public void begin(VariableDeclaratorIdNode node) {
    }

    @Override
    public void begin(FormalParameterDeclsNode node) {
        this.formalParameterDeclsVisitor = new FormalParameterDeclsVisitor(paramList);
    }

    @Override
    public void visit(VariableDeclaratorIdNode node) {
        return;
    }

    @Override
    public Visitor visit(FormalParameterDeclsNode node) {
        return this.formalParameterDeclsVisitor;
    }

    @Override
    public void end(VariableDeclaratorIdNode node) {
        this.varName = node.getName();
        /**
         * TODO: Insert variable name in symbol table and set value
         */
    }

    @Override
    public void end(FormalParameterDeclsNode node) {
    }

    public String getVarName() {
        return this.varName;
    }
}
