/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codegeneration.javavisitor.method;

import abstractsyntaxtree.FieldDeclaratorsRestNode;
import abstractsyntaxtree.MethodeDeclaratorRestNode;
import abstractsyntaxtree.ModifierNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractFieldDeclaratorsRestVisitor;
import codegeneration.abstractvisitors.AbstractMethodeOrFieldRestVisitor;
import codegeneration.abstractvisitors.AbstractTypeVisitor;
import codegeneration.javavisitor.FieldDeclaratorsRestVisitor;
import exceptions.CompilerException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import teajay.bytecode.ClassFile;
import teajay.bytecode.cpool.FieldDescriptor;
import teajay.bytecode.exceptions.ByteCodeException;
import teajay.bytecode.exceptions.MalformedClassNameException;
import teajay.bytecode.fields.FieldAccessFlag;
import teajay.bytecode.fields.FieldInfo;

/**
 *
 * @author cefour
 */
public class MethodeOrFieldRestVisitor extends AbstractMethodeOrFieldRestVisitor {

    private AbstractFieldDeclaratorsRestVisitor fieldDeclaratorsRestVisitor;
    private final ClassFile classFile;
    private final List<ModifierNode> modis;
    private final AbstractTypeVisitor typeVisitor;
    private final String name;

    MethodeOrFieldRestVisitor(ClassFile classFile, List<ModifierNode> modis, AbstractTypeVisitor typeVisitor, String name) {
        this.classFile = classFile;
        this.modis = modis;
        this.typeVisitor = typeVisitor;
        this.name = name;
    }

    @Override
    public void begin(FieldDeclaratorsRestNode node) throws CompilerException {
    }

    @Override
    public void begin(MethodeDeclaratorRestNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(FieldDeclaratorsRestNode node) throws CompilerException {
        return this.fieldDeclaratorsRestVisitor = new FieldDeclaratorsRestVisitor();
    }

    @Override
    public Visitor visit(MethodeDeclaratorRestNode node) throws CompilerException {
        return null;
    }

    @Override
    public void end(FieldDeclaratorsRestNode node) throws CompilerException {
        //Todo check is final to make value as constant
        try {
            FieldDescriptor desc = FieldDescriptor.fromString(this.typeVisitor.getTypeName());
            FieldInfo info = new FieldInfo(name, desc, FieldAccessFlag.PRIVATE);

            //  info.addAttribute(new ConstantValue("Was geht"));
            this.classFile.addField(info);

        } catch (MalformedClassNameException ex) {
            Logger.getLogger(MethodeOrFieldRestVisitor.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ByteCodeException ex) {
            Logger.getLogger(MethodeOrFieldRestVisitor.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    @Override
    public void end(MethodeDeclaratorRestNode node) throws CompilerException {
    }
}
