/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package lexer;

import exceptions.LexerException;
import java.io.IOException;

/**
 *
 * @author Michael Burzan
 */
public interface LexerWrapper {

    public int yyline();

    public int yycolumn();

    public String yytext();

    public Symbol yylex() throws IOException, LexerException;

    public void mark();

    public void reset();

    public void setTemplateState();

    public void resetTemplateState();

    public boolean lookahead(Rule rule);

    public boolean lookahead(int rule, int... rules);

    public boolean lookahead(Symbol symbol, int rule, int... rules);

    public void unmark();

    public Symbol getCurrentToken();
}