/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package resolve;

import java.io.DataInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.Enumeration;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;
import java.util.zip.ZipInputStream;
import exceptions.CompilerException;
import teajay.bytecode.ClassFile;
import teajay.bytecode.exceptions.ByteCodeException;

/**
 *
 * @author cefour
 * @deprecated
 */
public class Loader {

    private ZipInputStream jarInputStream;
    private static Loader instance = null;

    public static Loader instance() throws IOException, ByteCodeException, CompilerException {
        if (instance == null) {
            instance = new Loader();
        }
        return instance;
    }

    /**
     * This methods load the java.lang api.
     */
    private Loader() throws IOException, ByteCodeException, CompilerException {
        final String env = "sun.boot.class.path";
        final String property;
        String[] splitPaths;
        property = System.getProperty(env);
        String seperator = System.getProperty("path.separator");
        splitPaths = property.split(seperator);

        for (int i = 0; i < splitPaths.length; i++) {
            //this.jarInputStream = new ZipInputStream(new FileInputStream(splitPaths[0]));
            try {
                ZipFile zipFile = new ZipFile(splitPaths[i]);
                Enumeration<? extends ZipEntry> entries = zipFile.entries();
                while (entries.hasMoreElements()) {
                    ZipEntry entry = entries.nextElement();

                    String fileSep = System.getProperty("file.separator");

                    if (entry.getName().startsWith("java" + fileSep + "lang" + fileSep) && entry.getName().endsWith(".class")) {
                        InputStream stream = zipFile.getInputStream(entry);
                        DataInputStream s = new DataInputStream(stream);
                        ClassFile c = ClassFile.read(s);
                        SymbolTable.instance().addClass(entry.getName(), c);
                    }

                }
            } catch (FileNotFoundException exception) {
                // System.err.println(exception.getMessage());
            }

        }
    }

    public void loadJarFile(String fileName) {
    }

    public void loadJarDirectory(String path) {
    }

    public void loadClassDirectory(String path) {
    }

    public void loadClassFile(String path) {
    }

    /**
     * This method search in the rt.jar to resolve names.
     */
    void resolve(String qualifiedIdent) throws IOException, ByteCodeException, CompilerException {
        final String env = "sun.boot.class.path";
        final String property;
        String[] splitPaths;
        property = System.getProperty(env);
        String seperator = System.getProperty("path.separator");
        splitPaths = property.split(seperator);
        String fileName = qualifiedIdent + ".class";
        for (int i = 0; i < splitPaths.length; i++) {

            try {
                ZipFile zipFile = new ZipFile(splitPaths[i]);
                Enumeration<? extends ZipEntry> entries = zipFile.entries();
                while (entries.hasMoreElements()) {
                    ZipEntry entry = entries.nextElement();


                    if (entry.getName().equals(fileName)) {
                        InputStream stream = zipFile.getInputStream(entry);
                        DataInputStream s = new DataInputStream(stream);
                        ClassFile c = ClassFile.read(s);
                        SymbolTable.instance().addClass(entry.getName(), c);

                    }

                }
            } catch (FileNotFoundException exception) {
                // System.err.println(exception.getMessage());
            }

        }
    }
}
