/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage1;

import abstractsyntaxtree.BlockNode;
import abstractsyntaxtree.MemberDeclNode;
import abstractsyntaxtree.ModifierNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractClassBodyDeclarationVisitor;
import codegeneration.environment.Stage1Environment;
import codegeneration.javavisitor.classes.ClassBodyDeclarationVisitor;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
class Stage1ClassBodyDeclarationVisitor extends AbstractClassBodyDeclarationVisitor {
    private final Stage1Environment stage1Env;

    public Stage1ClassBodyDeclarationVisitor(Stage1Environment stage1Env) {
        this.stage1Env = stage1Env;
    }

    @Override
    public void begin(ModifierNode node) throws CompilerException {

    }

    @Override
    public void begin(MemberDeclNode node) throws CompilerException {

    }

    @Override
    public void begin(BlockNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(ModifierNode node) throws CompilerException {
        return null;
    }

    @Override
    public Visitor visit(MemberDeclNode node) throws CompilerException {
        return new Stage1MemberDeclVisitor(stage1Env);
    }

    @Override
    public Visitor visit(BlockNode node) throws CompilerException {
        return new Stage1BlockVisitor(stage1Env);
    }

    @Override
    public void end(ModifierNode node) throws CompilerException {

    }

    @Override
    public void end(MemberDeclNode node) throws CompilerException {

    }

    @Override
    public void end(BlockNode node) throws CompilerException {

    }
    
}
