/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage1;

import abstractsyntaxtree.GenericMethodeOrConstructorRestNode;
import abstractsyntaxtree.TypeParametersNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractGenericMethodeOrConstructorDeclVisitor;
import codegeneration.environment.Stage1Environment;
import exceptions.CompilerException;
import java.util.ArrayList;

/**
 *
 * @author Michael Burzan
 */
class Stage1GenericMethodOrConstructorDeclVisitor extends AbstractGenericMethodeOrConstructorDeclVisitor {
    private final Stage1Environment stage1Env;
    private Stage1GenericTypeParametersVisitor typeParamVisitor;

    public Stage1GenericMethodOrConstructorDeclVisitor(Stage1Environment stage1Env) {
        this.stage1Env = stage1Env;
    }

    @Override
    public void begin(TypeParametersNode node) throws CompilerException {
        //throw new CompilerException("Generic methods are not implemented yet", node.getSymbol());
    }

    @Override
    public void begin(GenericMethodeOrConstructorRestNode node) throws CompilerException {
        node.accept(new Stage1CreatorVisitor(stage1Env));
    }

    @Override
    public Visitor visit(TypeParametersNode node) throws CompilerException {
        stage1Env.createGenericMethodContext();
        return typeParamVisitor = new Stage1GenericTypeParametersVisitor(stage1Env);
    }

    @Override
    public Visitor visit(GenericMethodeOrConstructorRestNode node) throws CompilerException {
        return new Stage1TypeVisitor(stage1Env,new ArrayList<String>());
    }

    @Override
    public void end(TypeParametersNode node) throws CompilerException {
    }

    @Override
    public void end(GenericMethodeOrConstructorRestNode node) throws CompilerException {

    }
    
}
