/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage1;

import abstractsyntaxtree.ClassDeclarationNode;
import abstractsyntaxtree.ConstructorDeclaratorRestHelperNode;
import abstractsyntaxtree.GenericMethodeOrConstructorDeclNode;
import abstractsyntaxtree.InterfaceDeclarationNode;
import abstractsyntaxtree.MethodeOrFieldDeclNode;
import abstractsyntaxtree.VoidMethodeDeclaratorRestHelperNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractMemberDeclVisitor;
import codegeneration.environment.Stage1Environment;
import exceptions.CompilerException;
import java.util.ArrayList;

/**
 *
 * @author Michael Burzan
 */
class Stage1MemberDeclVisitor extends AbstractMemberDeclVisitor {
    private final Stage1Environment stage1Env;

    public Stage1MemberDeclVisitor(Stage1Environment stage1Env) {
        this.stage1Env = stage1Env;
    }

    @Override
    public void begin(MethodeOrFieldDeclNode node) throws CompilerException {
         node.accept(new Stage1CreatorVisitor(stage1Env));
    }

    @Override
    public void begin(VoidMethodeDeclaratorRestHelperNode node) throws CompilerException {
         node.accept(new Stage1CreatorVisitor(stage1Env));
    }

    @Override
    public void begin(ConstructorDeclaratorRestHelperNode node) throws CompilerException {
         node.accept(new Stage1CreatorVisitor(stage1Env));
    }

    @Override
    public void begin(GenericMethodeOrConstructorDeclNode node) throws CompilerException {

    }

    @Override
    public void begin(ClassDeclarationNode node) throws CompilerException {

    }

    @Override
    public void begin(InterfaceDeclarationNode node) throws CompilerException {
        
    }

    @Override
    public Visitor visit(MethodeOrFieldDeclNode node) throws CompilerException {
        return new Stage1TypeVisitor(stage1Env,new ArrayList<String>());
    }

    @Override
    public Visitor visit(VoidMethodeDeclaratorRestHelperNode node) throws CompilerException {
        return new Stage1TypeVisitor(stage1Env,new ArrayList<String>());
    }

    @Override
    public Visitor visit(ConstructorDeclaratorRestHelperNode node) throws CompilerException {
        return new Stage1TypeVisitor(stage1Env,new ArrayList<String>());
    }

    @Override
    public Visitor visit(GenericMethodeOrConstructorDeclNode node) throws CompilerException {
        return new Stage1GenericMethodOrConstructorDeclVisitor(stage1Env);
    }

    @Override
    public Visitor visit(ClassDeclarationNode node) throws CompilerException {
        return new Stage1ClassDeclarationVisitor(stage1Env);
    }

    @Override
    public Visitor visit(InterfaceDeclarationNode node) throws CompilerException {
        return new Stage1InterfaceDeclarationVisitor(stage1Env);
    }

    @Override
    public void end(MethodeOrFieldDeclNode node) throws CompilerException {

    }

    @Override
    public void end(VoidMethodeDeclaratorRestHelperNode node) throws CompilerException {

    }

    @Override
    public void end(ConstructorDeclaratorRestHelperNode node) throws CompilerException {

    }

    @Override
    public void end(GenericMethodeOrConstructorDeclNode node) throws CompilerException {
        stage1Env.dropGenericMethodContext();
    }

    @Override
    public void end(ClassDeclarationNode node) throws CompilerException {

    }

    @Override
    public void end(InterfaceDeclarationNode node) throws CompilerException {

    }
    
}
