/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.ClassDeclarationNode;
import abstractsyntaxtree.InterfaceDeclarationNode;
import abstractsyntaxtree.ModifierNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractClassOrInterfaceDeclarationVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Michael Burzan
 */
class Stage2ClassOrInterfaceDeclarationVisitor extends AbstractClassOrInterfaceDeclarationVisitor {
    private final Stage2Environment stage2Env;
    private final List<ModifierNode.Modifier> modifierList = new ArrayList<>();

    public Stage2ClassOrInterfaceDeclarationVisitor(Stage2Environment stage2Env) {
        this.stage2Env = stage2Env;
    }

    @Override
    public void begin(ModifierNode node) throws CompilerException {
        this.modifierList.add(node.getModifier());
    }

    @Override
    public Visitor visit(ModifierNode node) throws CompilerException {
        return null;
    }

    @Override
    public void end(ModifierNode node) throws CompilerException {

    }

    @Override
    public void begin(ClassDeclarationNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(ClassDeclarationNode node) throws CompilerException {
        
        return new Stage2ClassDeclarationVisitor(stage2Env,this.modifierList);
    }

    @Override
    public void end(ClassDeclarationNode node) throws CompilerException {

    }

    @Override
    public void begin(InterfaceDeclarationNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(InterfaceDeclarationNode node) throws CompilerException {
        return new Stage2InterfaceDeclarationVisitor(stage2Env,this.modifierList);
    }

    @Override
    public void end(InterfaceDeclarationNode node) throws CompilerException {

    }

    @Override
    public Object getClassFileContainer() throws CompilerException {
        return null;
    }
    
}
