/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.ClosureTypeFormalParamNode;
import abstractsyntaxtree.TypeNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractClosureTypeDecVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.util.ArrayList;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage2ClosureTypeDecVisitor extends AbstractClosureTypeDecVisitor {
    private final Stage2Environment stage2Env;
    private Stage2TypeVisitor typeVisitor;
    private Stage2ClosureTypeFormalParamVisitor formalParam;
    public Stage2ClosureTypeDecVisitor(Stage2Environment stage2Env) {
        this.stage2Env = stage2Env;
    }

    @Override
    public void begin(TypeNode node) throws CompilerException {
        this.typeVisitor = null;

    }

    @Override
    public void begin(ClosureTypeFormalParamNode node) throws CompilerException {
        this.formalParam = null;
    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return typeVisitor = new Stage2TypeVisitor(stage2Env);
    }

    @Override
    public Visitor visit(ClosureTypeFormalParamNode node) throws CompilerException {
        return formalParam = new Stage2ClosureTypeFormalParamVisitor(stage2Env);
    }

    @Override
    public void end(TypeNode node) throws CompilerException {

    }

    @Override
    public void end(ClosureTypeFormalParamNode node) throws CompilerException {
    }
    /**
     * 
     * @return a Type.ClassType closure with parameter
     * @throws CompilerException 
     */
    public Type getType() throws CompilerException{
        List<Type> param = new ArrayList<>();
        if (typeVisitor != null) {
            param.add(typeVisitor.getType());
        } else {
            param.add(new Type.ClassType(null, "java/lang/Void", null));
        }
        param.addAll(formalParam.getTypeList());
        return new Type.ClassType(null, "teajay/lang/Closure", param );
    }
    
}
