/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.TypeNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractClosureTypeFormalParamVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage2ClosureTypeFormalParamVisitor extends AbstractClosureTypeFormalParamVisitor {
    private final Stage2Environment stage2Env;
    private Stage2TypeVisitor typeVistor;
    private List<Type> formalParamList = new ArrayList<>();
    public Stage2ClosureTypeFormalParamVisitor(Stage2Environment stage2Env) {
        this.stage2Env = stage2Env;
    }

    @Override
    public void begin(TypeNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return typeVistor = new Stage2TypeVisitor(stage2Env);
    }

    @Override
    public void end(TypeNode node) throws CompilerException {
        formalParamList.add(typeVistor.getType());
    }
   
    List<? extends Type> getTypeList() {
            return formalParamList;

    }
    
}
