/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.ConstructorDeclaratorRestNode;
import abstractsyntaxtree.ModifierNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractConstructorDeclaratorRestHelperVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.util.Collections;
import java.util.List;
import stage2.utils.MethodHeadBuilder;
import teajay.bytecode.methods.MethodAccessFlag;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage2ConstructorDeclaratorRestHelperVisitor extends AbstractConstructorDeclaratorRestHelperVisitor {

    private final Stage2Environment stage2Env;
    private final List<ModifierNode> modis;
    private final String identifier;
    private Stage2MethodHeadVisitor constructorVisitor;

    public Stage2ConstructorDeclaratorRestHelperVisitor(Stage2Environment stage2Env, List<ModifierNode> modis, String identifier) {
        this.stage2Env = stage2Env;
        this.modis = modis;
        this.identifier = "<init>";

    }

    Stage2ConstructorDeclaratorRestHelperVisitor(Stage2Environment stage2Env, String identifier) {
        this.stage2Env = stage2Env;
        this.modis = Collections.EMPTY_LIST;
        this.identifier = "<init>";
    }

    @Override
    public void begin(ConstructorDeclaratorRestNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(ConstructorDeclaratorRestNode node) throws CompilerException {
        return constructorVisitor = new  Stage2MethodHeadVisitor(stage2Env);
    }
    /**
     * Creates the constructor head
     * @param node
     * @throws CompilerException 
     */
    @Override
    public void end(ConstructorDeclaratorRestNode node) throws CompilerException {
        MethodAccessFlag[] flags = MethodHeadBuilder.getMethodAccessFlags(identifier, modis);
        for (MethodAccessFlag flag : flags) {
            if (flag == MethodAccessFlag.STATIC) {
                throw new CompilerException("Constructors cannot have static modifier", node.getSymbol());
            }
        }
        MethodHeadBuilder.buildMethodHeadClass(node, stage2Env, new Type.SimpleType("void"), identifier, constructorVisitor.getMethodHead(), 
                                        flags);
    }
}
