/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.FormalParameterDeclsNode;
import abstractsyntaxtree.VariableDeclaratorIdNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractFormalParameterDeclsRestVisitor;
import codegeneration.environment.Stage2Environment;
import datastructs.Pair;
import exceptions.CompilerException;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage2FormalParameterDeclsRestVisitor extends AbstractFormalParameterDeclsRestVisitor {
    private final Stage2Environment stage2Env;
    private final List<Pair<Type, String>> formalParameterList;
    private String name;
    private final boolean isVararg;

    public Stage2FormalParameterDeclsRestVisitor(Stage2Environment stage2Env, List<Pair<Type, String>> formalParameterList,boolean isVararg) {
        this.stage2Env = stage2Env;
        this.formalParameterList = formalParameterList;
        this.isVararg = isVararg;
    }

    String getName() {
        return name;
    }

    @Override
    public void begin(VariableDeclaratorIdNode node) throws CompilerException {

    }

    @Override
    public void begin(FormalParameterDeclsNode node) throws CompilerException {
        if(isVararg){
            throw new CompilerException("It's not allowed to declare additional parameters after a vararg parameter", node.getSymbol());
        }
    }

    @Override
    public void visit(VariableDeclaratorIdNode node) throws CompilerException {
        this.name = node.getName();
    }

    @Override
    public Visitor visit(FormalParameterDeclsNode node) throws CompilerException {
        
        return new Stage2FormalParameterDeclsVisitor(stage2Env, formalParameterList);
    }

    @Override
    public void end(VariableDeclaratorIdNode node) throws CompilerException {

    }

    @Override
    public void end(FormalParameterDeclsNode node) throws CompilerException {

    }
    
}
