/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.FormalParameterDeclsRestNode;
import abstractsyntaxtree.TypeNode;
import abstractsyntaxtree.VariableModifierNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractFormalParameterDeclsVisitor;
import codegeneration.environment.Stage2Environment;
import datastructs.Pair;
import exceptions.CompilerException;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage2FormalParameterDeclsVisitor extends AbstractFormalParameterDeclsVisitor {

    private final Stage2Environment stage2Env;
    private final List<Pair<Type, String>> formalParameterList;
    private Stage2TypeVisitor stage2Type;
    private Stage2FormalParameterDeclsRestVisitor formalParametersDeclsRest;

    public Stage2FormalParameterDeclsVisitor(Stage2Environment stage2Env, List<Pair<Type, String>> formalParameterList) {
        this.stage2Env = stage2Env;
        this.formalParameterList = formalParameterList;
    }

    @Override
    public void begin(VariableModifierNode node) throws CompilerException {
    }

    @Override
    public void begin(TypeNode node) throws CompilerException {
    }

    @Override
    public void begin(FormalParameterDeclsRestNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(VariableModifierNode node) throws CompilerException {
        return null;
    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return stage2Type = new Stage2TypeVisitor(stage2Env);
    }

    @Override
    public Visitor visit(FormalParameterDeclsRestNode node) throws CompilerException {
       
        return formalParametersDeclsRest = new Stage2FormalParameterDeclsRestVisitor(stage2Env, this.formalParameterList, node.hasTriplePoint());
    }

    @Override
    public void end(VariableModifierNode node) throws CompilerException {
    }

    @Override
    public void end(TypeNode node) throws CompilerException {
    }

    @Override
    public void end(FormalParameterDeclsRestNode node) throws CompilerException {
        if (node.hasTriplePoint()) {
            Type type = stage2Type.getType();
            Type.ArrayType aType = new Type.ArrayType(type);
            this.formalParameterList.add(new Pair<Type, String>(aType, formalParametersDeclsRest.getName()));
        } else {
           this.formalParameterList.add(new Pair<Type, String>(stage2Type.getType(), formalParametersDeclsRest.getName()));
        }
    }
}
