/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.InterfaceMemberDeclNode;
import abstractsyntaxtree.ModifierNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractInterfaceBodyDeclarationVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Michael Burzan
 */
class Stage2InterfaceBodyDeclarationVisitor extends AbstractInterfaceBodyDeclarationVisitor {
    private final Stage2Environment stage2Env;
    private final List<ModifierNode.Modifier> flagList = new ArrayList<>();
    public Stage2InterfaceBodyDeclarationVisitor(Stage2Environment stage2Env) {
        this.stage2Env = stage2Env;
    }

    @Override
    public void begin(ModifierNode node) throws CompilerException {
        if(node.getModifier() == ModifierNode.Modifier.ABSTRACT
           || node.getModifier() == ModifierNode.Modifier.NATIVE
           || node.getModifier() == ModifierNode.Modifier.PRIVATE
           || node.getModifier() == ModifierNode.Modifier.PROTECTED
           || node.getModifier() == ModifierNode.Modifier.STATIC){
           
            throw new CompilerException("Modifier " + node.getModifier() + " not allowed", node.getSymbol());
        }
        this.flagList.add(node.getModifier());
    }

    @Override
    public void begin(InterfaceMemberDeclNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(ModifierNode node) throws CompilerException {
        return null;
    }

    @Override
    public Visitor visit(InterfaceMemberDeclNode node) throws CompilerException {
        return new Stage2InterfaceMemberDeclVisitor(stage2Env,node.getIdentifier(),flagList);
    }

    @Override
    public void end(ModifierNode node) throws CompilerException {

    }

    @Override
    public void end(InterfaceMemberDeclNode node) throws CompilerException {

    }
    
}
