/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.ConstantDeclaratorRestNode;
import abstractsyntaxtree.InterfaceMethodDeclaratorRestNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractInterfaceMethodOrFieldRestVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import stage2.utils.MethodHeadBuilder;
import teajay.bytecode.methods.MethodAccessFlag;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage2InterfaceMethodOrFieldRestVisitor extends AbstractInterfaceMethodOrFieldRestVisitor {
    private final Stage2Environment stage2Env;
    private final String methodName;
    private final MethodAccessFlag[] methodAccessFlags;
    private final Type returnType;
    private Stage2MethodHeadVisitor stage2InterfaceMethodDecl;

    public Stage2InterfaceMethodOrFieldRestVisitor(Stage2Environment stage2Env, String methodName,
            MethodAccessFlag[] methodAccessFlag, Type type) {
        this.stage2Env = stage2Env;
        this.methodName = methodName;
        this.methodAccessFlags = methodAccessFlag;
        this.returnType = type;
    }

    @Override
    public void begin(ConstantDeclaratorRestNode node) throws CompilerException {

    }

    @Override
    public void begin(InterfaceMethodDeclaratorRestNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(ConstantDeclaratorRestNode node) throws CompilerException {
        throw new CompilerException("Variable declaration in interface is not allowed",node.getSymbol());
    }

    @Override
    public Visitor visit(InterfaceMethodDeclaratorRestNode node) throws CompilerException {
        return  stage2InterfaceMethodDecl = new Stage2MethodHeadVisitor(stage2Env);
    }

    @Override
    public void end(ConstantDeclaratorRestNode node) throws CompilerException {

    }

    @Override
    public void end(InterfaceMethodDeclaratorRestNode node) throws CompilerException {
        MethodHeadBuilder.buildInterfaceMethodHead(stage2Env, methodAccessFlags, returnType, methodName, stage2InterfaceMethodDecl.getMethodHead(),
                            node, null, false);
    }
    
}
