/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.BlockNode;
import abstractsyntaxtree.FormalParametersNode;
import abstractsyntaxtree.QualifiedIdentifierListNode;
import codegeneration.Visitor;
import codegeneration.environment.Stage2Environment;
import codegeneration.javavisitor.QualifiedIdentifierListVisitor;
import datastructs.Pair;
import exceptions.CompilerException;
import java.util.List;
import stage2.utils.MethodHeadBuilder;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
public class Stage2MethodHeadVisitor extends Visitor {
    private final Stage2Environment stage2Env;
    private Stage2FormalParametersVisitor formalParameters;
    private QualifiedIdentifierListVisitor throwsList;

    public Stage2MethodHeadVisitor(Stage2Environment stage2Env) {
        this.stage2Env = stage2Env;
    }

    @Override
    public void begin(FormalParametersNode node) throws CompilerException {

    }

    @Override
    public void begin(QualifiedIdentifierListNode node) throws CompilerException {

    }

    @Override
    public void begin(BlockNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(FormalParametersNode node) throws CompilerException {
        return formalParameters = new Stage2FormalParametersVisitor(stage2Env);
    }

    @Override
    public Visitor visit(QualifiedIdentifierListNode node) throws CompilerException {
        return throwsList = new QualifiedIdentifierListVisitor();
    }

    @Override
    public Visitor visit(BlockNode node) throws CompilerException {
        return null;
    }

    @Override
    public void end(FormalParametersNode node) throws CompilerException {
        node.setFormalParameters(formalParameters.getFieldContainer());
    }

    @Override
    public void end(QualifiedIdentifierListNode node) throws CompilerException {
        node.setQualifiedIndentifierList(throwsList.getQualifiedIdentifiers());
    }

    @Override
    public void end(BlockNode node) throws CompilerException {

    }
    /**
     * 
     * @return Pair: the first attribute is a List of Pair with Type and String. 
     * This list represented the parameters of a method. The second attribute is a List of String this represented the throws List  
     * @throws CompilerException 
     */
    public Pair<List<Pair<Type, String>>, List<String>> getMethodHead()throws CompilerException{
        return MethodHeadBuilder.makeMethodHead(formalParameters, throwsList);
    }
}
