/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.MethodeOrFieldRestNode;
import abstractsyntaxtree.ModifierNode;
import abstractsyntaxtree.TypeNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractMethodeOrFieldDeclVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.util.Collection;
import java.util.List;
import teajay.bytecode.methods.MethodInfo;

/**
 *
 * @author Michael Burzan
 */
class Stage2TjImplMethodOrFieldVisitor extends AbstractMethodeOrFieldDeclVisitor {
    private final Stage2Environment stage2Env;
    private final List<ModifierNode.Modifier> flagList;
    private final Collection<List<MethodInfo>> methods;
    private final String fieldOrMethodName;
    private Stage2TypeVisitor stage2Type;

    public Stage2TjImplMethodOrFieldVisitor(Stage2Environment stage2Env, List<ModifierNode.Modifier> flagList, Collection<List<MethodInfo>> methods, String identifier) {
        this.stage2Env = stage2Env;
        this.flagList = flagList;
        this.methods = methods;
        this.fieldOrMethodName = identifier;
    }

    
    @Override
    public void begin(TypeNode node) throws CompilerException {
        
    }

    @Override
    public void begin(MethodeOrFieldRestNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return stage2Type = new Stage2TypeVisitor(stage2Env);
    }

    @Override
    public Visitor visit(MethodeOrFieldRestNode node) throws CompilerException {
        return new Stage2TjImplMethodeOrFieldRestVisitor(stage2Env,flagList,methods,
                                        fieldOrMethodName,stage2Type.getType());
    }

    @Override
    public void end(TypeNode node) throws CompilerException {

    }

    @Override
    public void end(MethodeOrFieldRestNode node) throws CompilerException {

    }
    
}
