/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.InterfaceMethodDeclaratorRestNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractTjTypeDefConstructorDeclVisitor;
import codegeneration.environment.Stage2Environment;
import datastructs.Pair;
import exceptions.CompilerException;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage2TjTypeDefConstructorDeclVisitor extends AbstractTjTypeDefConstructorDeclVisitor{
    private final Stage2Environment stage2Env;
    private Stage2MethodHeadVisitor stage2InterfaceMethodDeclRest;

    public Stage2TjTypeDefConstructorDeclVisitor(Stage2Environment stage2Env) {
        this.stage2Env = stage2Env;
    }

    @Override
    public void begin(InterfaceMethodDeclaratorRestNode node) throws CompilerException {
        
    }

    @Override
    public Visitor visit(InterfaceMethodDeclaratorRestNode node) throws CompilerException {
        return stage2InterfaceMethodDeclRest = new Stage2MethodHeadVisitor(stage2Env);
    }

    @Override
    public void end(InterfaceMethodDeclaratorRestNode node) throws CompilerException {
        
    }
    /**
     * 
     * @return Pair: The first attribute is a List of Pair with Type and String 
     * this represents the method parameter. The second attribute is a List of String this
     * represents the throws List
     * @throws CompilerException 
     */
    public Pair<List<Pair<Type, String>>, List<String>> getMethodHead() throws CompilerException{
         return stage2InterfaceMethodDeclRest.getMethodHead();
    }
    
    
}
