/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.TypeArgumentNode;
import abstractsyntaxtree.TypeArgumentsListHelperNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractTypeArgumentsVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.util.ArrayList;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage2TypeArgumentsVisitor extends AbstractTypeArgumentsVisitor {

    private final Stage2Environment stage2Env;
    private Stage2TypeArgumentVisitor stage2TypeArgument;
    private List<Type> typeList = new ArrayList<>();
    private Stage2TypeArgumentsListHelperVisitor stage2TypeArgumentsListHelper;

    public Stage2TypeArgumentsVisitor(Stage2Environment stage2Env) {
        this.stage2Env = stage2Env;
    }

    @Override
    public void begin(TypeArgumentNode node) throws CompilerException {
    }

    @Override
    public void begin(TypeArgumentsListHelperNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(TypeArgumentNode node) throws CompilerException {
        return stage2TypeArgument = new Stage2TypeArgumentVisitor(stage2Env);
    }

    @Override
    public Visitor visit(TypeArgumentsListHelperNode node) throws CompilerException {
        return stage2TypeArgumentsListHelper = new Stage2TypeArgumentsListHelperVisitor(stage2Env);
    }

    @Override
    public void end(TypeArgumentNode node) throws CompilerException {
        Type type;
        //<? extends Type | ? super Type>
        if (node.hasQuestionMark()) {
            type = new Type.WildcardType(Type.WildcardType.Kind.UNBOUNDED, stage2TypeArgument.getType());
            if (node.hasExtendsOf()) {
                type = new Type.WildcardType(Type.WildcardType.Kind.EXTENDS, stage2TypeArgument.getType());
            } else {
                if (node.hasSuperOf()) {
                    type = new Type.WildcardType(Type.WildcardType.Kind.SUPER, stage2TypeArgument.getType());
                }
            }
        } else {
            type = stage2TypeArgument.getType();
        }
        this.typeList.add(type);

    }

    @Override
    public void end(TypeArgumentsListHelperNode node) throws CompilerException {
        this.typeList.addAll(this.stage2TypeArgumentsListHelper.getTypeList());
    
    }
    public List<Type> getTypes(){
        return this.typeList;
    }
}
