/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2;

import abstractsyntaxtree.ModifierNode;
import abstractsyntaxtree.VoidMethodeDeclaratorRestNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractVoidMethodeDeclaratorRestHelperVisitor;
import codegeneration.environment.Stage2Environment;
import exceptions.CompilerException;
import java.util.Collections;
import java.util.List;
import stage2.utils.MethodHeadBuilder;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage2VoidMethodeDeclaratorRestHelperVisitor extends AbstractVoidMethodeDeclaratorRestHelperVisitor {
    private final Stage2Environment stage2Env;
    private final List<ModifierNode> modis;
    private final String methodName;
    private Stage2MethodHeadVisitor stage2VoidMethod;

    public Stage2VoidMethodeDeclaratorRestHelperVisitor(Stage2Environment stage2Env, List<ModifierNode> modis, String methodName) {
        this.stage2Env = stage2Env;
        this.modis = modis;
        this.methodName = methodName;
    }

    Stage2VoidMethodeDeclaratorRestHelperVisitor(Stage2Environment stage2Env, String methodName) {
        this.stage2Env = stage2Env;
        this.methodName = methodName;
        this.modis = Collections.EMPTY_LIST;

    }

    @Override
    public void begin(VoidMethodeDeclaratorRestNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(VoidMethodeDeclaratorRestNode node) throws CompilerException {
        return stage2VoidMethod = new Stage2MethodHeadVisitor(stage2Env);
    }

    @Override
    public void end(VoidMethodeDeclaratorRestNode node) throws CompilerException {
        MethodHeadBuilder.buildMethodHeadClass(node, stage2Env, new Type.SimpleType("void"), methodName, stage2VoidMethod.getMethodHead(), 
                MethodHeadBuilder.getMethodAccessFlags(methodName, modis));
    }
    
}
