/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage2.utils;

import abstractsyntaxtree.ModifierNode;
import exceptions.CompilerException;
import java.util.Collection;
import teajay.bytecode.methods.MethodAccessFlag;

/**
 *
 * @author Michael Burzan
 */
public class Converter {
    public static MethodAccessFlag[] convertModifierToMethodAccesFlags(Collection<ModifierNode.Modifier> modifier)throws CompilerException{
        MethodAccessFlag[] accessFlags = new MethodAccessFlag[modifier.size()];
        int i = 0;
        for(ModifierNode.Modifier modi : modifier){
            switch(modi){
                case PUBLIC:
                    accessFlags[i] = MethodAccessFlag.PUBLIC;
                    i++;
                    break;
                case PROTECTED:
                    accessFlags[i] = MethodAccessFlag.PROTECTED;
                    i++;
                    break;
                case PRIVATE:
                    accessFlags[i] = MethodAccessFlag.PRIVATE;
                    i++;
                    break;
                case STATIC:
                    accessFlags[i] = MethodAccessFlag.STATIC;
                    i++;
                    break;
                case ABSTRACT:
                    accessFlags[i] = MethodAccessFlag.ABSTRACT;
                    i++;
                    break;
                case FINAL:
                    accessFlags[i] = MethodAccessFlag.FINAL;
                    i++;
                    break;
                case NATIVE:
                    accessFlags[i] = MethodAccessFlag.NATIVE;
                    i++;
                    break;
                case SYNCHRONIZED:
                    accessFlags[i] = MethodAccessFlag.SYNCHRONIZED;
                    i++;
                    break;
                case TRANSIENT:
                    throw new CompilerException("Transient not supported for methods");
                case VOLATILE:
                    throw new CompilerException("Volatile not supported for methods");
                case STRICTFP:
                    accessFlags[i] = MethodAccessFlag.STRICT;
                    i++;
                    break;
                default:
                    throw new AssertionError(modi.name());
                
            }
        }
        return accessFlags;
    }
}
