/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.ClassBodyDeclarationNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractClassBodyVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import stage3.utils.ConstructorFieldInitBuilder;
import stage3.utils.StaticConstructorFieldInitBuilder;

/**
 *
 * @author Michael Burzan
 */
class Stage3ClassBodyVisitor extends AbstractClassBodyVisitor {

    private final Stage3Environment stage3Env;
    private Stage3ClassBodyDeclarationVisitor classBodyDecl;
    private boolean isFirst;

    public Stage3ClassBodyVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
        this.stage3Env.createThis();
        this.stage3Env.setConstructorFieldInitBuilder(new ConstructorFieldInitBuilder());
        this.stage3Env.setStaticConstructorFieldInitBuilder(new StaticConstructorFieldInitBuilder());
        this.isFirst = true;
    }

    @Override
    public void begin(ClassBodyDeclarationNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(ClassBodyDeclarationNode node) throws CompilerException {
        return classBodyDecl = new Stage3ClassBodyDeclarationVisitor(stage3Env, node.hasStaticBlock());
    }

    @Override
    /*
     * whether are all field declaration the first statements in typimpl     
     */
    public void end(ClassBodyDeclarationNode node) throws CompilerException {
        if(!this.isFirst){
            if(classBodyDecl.isFieldDeclaration()){
                throw new CompilerException("Field declaration not allowed here", node.getSymbol());
            }
        }else{
            if(!classBodyDecl.isFieldDeclaration()){
                this.isFirst = false;
            }
        }
    }
}
