/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.ClosureEnvItemNode;
import abstractsyntaxtree.ExpressionNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractClosureEnvListVisitor;
import codegeneration.environment.Stage3Environment;
import datastructs.Pair;
import exceptions.CompilerException;
import java.util.HashMap;
import java.util.Map;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage3ClosureEnvListVisitor extends AbstractClosureEnvListVisitor {
    private final Stage3Environment stage3Env;
    private Stage3ClosureEnvItemVisitor closureEnvItem;
    private Map<String,Pair<Type,ExpressionNode>> cEnvironment = new HashMap<>();
    
    
    public Stage3ClosureEnvListVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
    }

    @Override
    public void begin(ClosureEnvItemNode node) throws CompilerException {
        
    }

    @Override
    public Visitor visit(ClosureEnvItemNode node) throws CompilerException {
        return closureEnvItem =  new Stage3ClosureEnvItemVisitor(stage3Env);
    }

    @Override
    public void end(ClosureEnvItemNode node) throws CompilerException {
        this.cEnvironment.put(node.getIdentifier(),closureEnvItem.getEnvItem());
    }
    /**
     * 
     * @return the colosure environmant 
     */
    public Map<String, Pair<Type, ExpressionNode>> getClosureEnvironment(){
        return this.cEnvironment;
    }
    
    
    
    
}
