/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.TypeNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractClosureTypeFormalParamVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import java.util.LinkedList;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage3ClosureTypeFormalParamVisitor extends AbstractClosureTypeFormalParamVisitor {
    private final Stage3Environment stage3Env;
    private Stage3TypeVisitor typeVisitor;
    private final List<Type> typeList = new LinkedList<>();

    public Stage3ClosureTypeFormalParamVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
    }

    @Override
    public void begin(TypeNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return typeVisitor = new Stage3TypeVisitor(stage3Env);
    }

    @Override
    public void end(TypeNode node) throws CompilerException {
        typeList.add(typeVisitor.getType());
    }
    
    public List<Type> getTypes() throws CompilerException{
        return typeList;
    }
    
}
