/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.BasicTypeNode;
import abstractsyntaxtree.TypeArgumentsOrDiamondNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractCreatedNameVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage3CreatedNameVisitor extends AbstractCreatedNameVisitor {
    private final Stage3Environment stage3Env;
    private final String typeDefName;
    private Stage3TypeArgumentsOrDiamondVisitor typeArgumnetsOrDiamondVisitor;
    private boolean isDiamond = false;

    public Stage3CreatedNameVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
        this.typeDefName = null;
    }

    

    @Override
    public void begin(TypeArgumentsOrDiamondNode node) throws CompilerException {
        this.isDiamond = node.isDiamond();
    }

    @Override
    public void begin(BasicTypeNode node) throws CompilerException {
        
    }

    @Override
    public Visitor visit(TypeArgumentsOrDiamondNode node) throws CompilerException {
        
        return this.typeArgumnetsOrDiamondVisitor = new Stage3TypeArgumentsOrDiamondVisitor(stage3Env);
    }

    @Override
    public void visit(BasicTypeNode node) throws CompilerException {
        
    }

    @Override
    public void end(TypeArgumentsOrDiamondNode node) throws CompilerException {
        
    }

    @Override
    public void end(BasicTypeNode node) throws CompilerException {
        
    }
    public boolean isDiamond(){
        return this.isDiamond;
    }
    
    public List<Type> getTypeParams() {
        if(this.isDiamond){
            return null;
        }else{
            if(typeArgumnetsOrDiamondVisitor == null) return null;
            return this.typeArgumnetsOrDiamondVisitor.getTypeParams();
        }
    }
    
}
