/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.ExplicitGenericInvocationNode;
import abstractsyntaxtree.ExplicitGenericInvocationSuffixNode;
import abstractsyntaxtree.NonWildcardTypeArgumentsNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractExplicitGenericInvocationVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import java.util.List;
import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage3ExplicitGenericInvocationVisitor extends AbstractExplicitGenericInvocationVisitor {
    private final Stage3Environment stage3Env;
    private Stage3NonWildcardTypeArgumentsVisitor nonWildcardTypeArgumentsVisitor;
    private String methodName;

    public Stage3ExplicitGenericInvocationVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
    }

    @Override
    public void begin(NonWildcardTypeArgumentsNode node) throws CompilerException {
        
    }

    @Override
    public void begin(ExplicitGenericInvocationSuffixNode node) throws CompilerException {
        
    }

    @Override
    public Visitor visit(NonWildcardTypeArgumentsNode node) throws CompilerException {
        return nonWildcardTypeArgumentsVisitor = new Stage3NonWildcardTypeArgumentsVisitor(stage3Env);
    }

    @Override
    public Visitor visit(ExplicitGenericInvocationSuffixNode node) throws CompilerException {
        return new Stage3ExplicitGenericInvocationSuffixVisitor(stage3Env);
    }

    @Override
    public void end(NonWildcardTypeArgumentsNode node) throws CompilerException {
    }

    @Override
    public void end(ExplicitGenericInvocationSuffixNode node) throws CompilerException {
        this.methodName = node.getIdentifier();
    }
    
    public String getMethodName() {
        return methodName;
    }
    
    public List<Type> getGenericArgs() {
        return nonWildcardTypeArgumentsVisitor.getTypeList();
    }
    
}
