/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.Expression2RestNode;
import abstractsyntaxtree.Expression3Node;
import abstractsyntaxtree.InfixOpNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractExpression2Visitor;
import codegeneration.environment.ExpressionEnvironment;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import java.util.Deque;

/**
 *
 * @author Michael Burzan
 */
class Stage3Expression2Visitor extends AbstractExpression2Visitor {
    private final Stage3Environment stage3Env;
    private final Deque<InfixOpNode.InfixOps> stack;
    private final boolean hasDup;

   

    Stage3Expression2Visitor(Stage3Environment stage3Env, Deque<InfixOpNode.InfixOps> stack,boolean hasDup) {
        this.stage3Env = stage3Env;
        this.stack = stack;
        this.hasDup = hasDup;
    }

    @Override
    public void begin(Expression3Node node) throws CompilerException {

    }

    @Override
    public void begin(Expression2RestNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(Expression3Node node) throws CompilerException {
        ExpressionEnvironment env = stage3Env.getExpressionEnvironment();
        //check is expression LValue or RValue
        if (node.hasAssignment()) {
            env.setLValue(node.getAssignOp());
            return new Stage3Expression3Visitor(stage3Env, this.stack, hasDup);
        }
        env.setRValue();
        return new Stage3Expression3Visitor(stage3Env, this.stack, false);
    }

    @Override
    public Visitor visit(Expression2RestNode node) throws CompilerException {
        return new Stage3Expression2RestVisitor(stage3Env,stack);
    }

    @Override
    public void end(Expression3Node node) throws CompilerException {
    }

    @Override
    public void end(Expression2RestNode node) throws CompilerException {

    }
    
}
