/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.ExpressionNode;
import abstractsyntaxtree.ForInitNode;
import abstractsyntaxtree.ForUpdateNode;
import abstractsyntaxtree.ForVarControlNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractForControlVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import teajay.bytecode.attributes.code.Label;

/**
 *
 * @author Michael Burzan
 */
class Stage3ForControlVisitor extends AbstractForControlVisitor {
    private final Stage3Environment stage3Env;
    private Stage3ForVarControlVisitor forVarControl;
    private Label label;
    private Label loopLabel;

    public Stage3ForControlVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
    }

    @Override
    public void begin(ForVarControlNode node) throws CompilerException {

    }

    @Override
    public void begin(ForInitNode node) throws CompilerException {

    }

    @Override
    public void begin(ExpressionNode node) throws CompilerException {

    }

    @Override
    public void begin(ForUpdateNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(ForVarControlNode node) throws CompilerException {
        return forVarControl = new Stage3ForVarControlVisitor(stage3Env);
    }

    @Override
    public Visitor visit(ForInitNode node) throws CompilerException {
        return new Stage3ForInitVisitor(stage3Env);
    }

    @Override
    public Visitor visit(ExpressionNode node) throws CompilerException {
        return null;
    }

    @Override
    public Visitor visit(ForUpdateNode node) throws CompilerException {
        return null;
    }

    @Override
    public void end(ForVarControlNode node) throws CompilerException {
        this.label = forVarControl.getLabel();
        this.loopLabel = forVarControl.getLoopLabel();
    }

    @Override
    public void end(ForInitNode node) throws CompilerException {

    }

    @Override
    public void end(ExpressionNode node) throws CompilerException {

    }

    @Override
    public void end(ForUpdateNode node) throws CompilerException {

    }
    public Label getLabel(){
        return this.label;
    }
    public Label getLoopLabel(){
        return this.loopLabel;
    }
    
}
