/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.MethodeOrFieldRestNode;
import abstractsyntaxtree.TypeNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractMethodeOrFieldDeclVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
class Stage3MethodOrFieldDeclVisitor extends AbstractMethodeOrFieldDeclVisitor {
    private final Stage3Environment stage3Env;
    private final String methodOrFieldName;
    private Stage3TypeVisitor typeVisitor;
    private boolean isFieldDecl = false;;
    private Stage3MethodOrFieldRestVisitor methodOrFieldRest;

    public Stage3MethodOrFieldDeclVisitor(Stage3Environment stage3Env, String identifier) {
        this.stage3Env = stage3Env;
        this.methodOrFieldName = identifier;
    }

    @Override
    public void begin(TypeNode node) throws CompilerException {

    }

    @Override
    public void begin(MethodeOrFieldRestNode node) throws CompilerException {

    }

    @Override
    public Visitor visit(TypeNode node) throws CompilerException {
        return typeVisitor = new Stage3TypeVisitor(stage3Env);
    }

    @Override
    public Visitor visit(MethodeOrFieldRestNode node) throws CompilerException {
        return methodOrFieldRest = new Stage3MethodOrFieldRestVisitor(stage3Env,methodOrFieldName,typeVisitor.getType());
    }

    @Override
    public void end(TypeNode node) throws CompilerException {

    }

    @Override
    public void end(MethodeOrFieldRestNode node) throws CompilerException {
        this.isFieldDecl = methodOrFieldRest.isFieldDeclaration();
    }

    public boolean isFielDeclaration() {
        return this.isFieldDecl;
    }
    
}
