/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.DotIdentifierTypeArgumentsHelperNode;
import abstractsyntaxtree.TypeArgumentsNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractReferenceTypeVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import java.util.Collections;
import java.util.List;

import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage3ReferenceTypeVisitor extends AbstractReferenceTypeVisitor{

     private final Stage3Environment stage3Env;
    private final List<String> identList;
    private Stage3TypeArgumentsVisitor stage3TypeArgumentsVisitor;
    private Stage3DotIdentifierTypeArgumentsHelperVisitor stage3DotIdentifierTypeArgumentsHelper;
    
    public Stage3ReferenceTypeVisitor(Stage3Environment stage3Env, List<String> identList) {
        this.stage3Env = stage3Env;
        this.identList = identList;
    }
    /**
     * @description returns the TypeParameters of reference type: Example List<String> => String
     * @return List<Type> 
     */
    public List<Type> getTypeParameters() {
        if(stage3TypeArgumentsVisitor == null){
            if(stage3DotIdentifierTypeArgumentsHelper == null){
                return Collections.EMPTY_LIST;
            }
            return stage3DotIdentifierTypeArgumentsHelper.getTypeArguments();
        }
        return stage3TypeArgumentsVisitor.getTypes();
        
    }

    @Override
    public void begin(TypeArgumentsNode node) throws CompilerException {
       
    }

    @Override
    public Visitor visit(TypeArgumentsNode node) throws CompilerException {
        return stage3TypeArgumentsVisitor = new Stage3TypeArgumentsVisitor(stage3Env);
    }

    @Override
    public void end(TypeArgumentsNode node) throws CompilerException {
       
    }

    @Override
    /**
     * Build reference type name
     */
    public void begin(DotIdentifierTypeArgumentsHelperNode node) throws CompilerException {
       identList.add(node.getIdentifier());
    }

    @Override
    public Visitor visit(DotIdentifierTypeArgumentsHelperNode node) throws CompilerException {
        return stage3DotIdentifierTypeArgumentsHelper = new Stage3DotIdentifierTypeArgumentsHelperVisitor(stage3Env);
    }

    @Override
    public void end(DotIdentifierTypeArgumentsHelperNode node) throws CompilerException {
       
    }
    
}
