/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.BlockStatementsNode;
import abstractsyntaxtree.SwitchLabelsNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractSwitchBlockStatementGroupVisitor;
import codegeneration.environment.ExpressionEnvironment;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import teajay.bytecode.attributes.code.JVMInstructionList;
import teajay.bytecode.attributes.code.Switch;

/**
 *
 * @author Michael Burzan
 * Not supported in TeaJay
 */
class Stage3SwitchBlockStatementGroupVisitor extends AbstractSwitchBlockStatementGroupVisitor {
    private final Stage3Environment stage3Env;

    public Stage3SwitchBlockStatementGroupVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
    }

    @Override
    public void begin(SwitchLabelsNode node) throws CompilerException {
  
    }

    @Override
    public void begin(BlockStatementsNode node) throws CompilerException {
  
    }

    @Override
    public Visitor visit(SwitchLabelsNode node) throws CompilerException {
       return new Stage3SwitchLabelsVisitor(stage3Env);
  
    }

    @Override
    public Visitor visit(BlockStatementsNode node) throws CompilerException {
        return new Stage3BlockStatementsVisitor(stage3Env);
    }

    @Override
    public void end(SwitchLabelsNode node) throws CompilerException {
        ExpressionEnvironment env = stage3Env.getExpressionEnvironment();
        JVMInstructionList ins = env.getMethod().getCode().getInstructionList();
        Switch s = new Switch();
    }

    @Override
    public void end(BlockStatementsNode node) throws CompilerException {
  
    }
    
}
