/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3;

import abstractsyntaxtree.TypeArgumentNode;
import abstractsyntaxtree.TypeArgumentsListHelperNode;
import codegeneration.Visitor;
import codegeneration.abstractvisitors.AbstractTypeArgumentsVisitor;
import codegeneration.environment.Stage3Environment;
import exceptions.CompilerException;
import java.util.ArrayList;
import java.util.List;

import teajay.generics.parser.Type;

/**
 *
 * @author Michael Burzan
 */
class Stage3TypeArgumentsVisitor extends AbstractTypeArgumentsVisitor{

    private final Stage3Environment stage3Env;
    private Stage3TypeArgumentVisitor stage3TypeArgument;
    private List<Type> typeList = new ArrayList<>();
    private Stage3TypeArgumentsListHelperVisitor stage3TypeArgumentsListHelper;

    public Stage3TypeArgumentsVisitor(Stage3Environment stage3Env) {
        this.stage3Env = stage3Env;
    }

    @Override
    public void begin(TypeArgumentNode node) throws CompilerException {
    }

    @Override
    public void begin(TypeArgumentsListHelperNode node) throws CompilerException {
    }

    @Override
    public Visitor visit(TypeArgumentNode node) throws CompilerException {
        return stage3TypeArgument = new Stage3TypeArgumentVisitor(stage3Env);
    }

    @Override
    public Visitor visit(TypeArgumentsListHelperNode node) throws CompilerException {
        return stage3TypeArgumentsListHelper = new Stage3TypeArgumentsListHelperVisitor(stage3Env);
    }

    @Override
    public void end(TypeArgumentNode node) throws CompilerException {
        Type type;
        if (node.hasQuestionMark()) {
            type = new Type.WildcardType(Type.WildcardType.Kind.UNBOUNDED, stage3TypeArgument.getType());
            if (node.hasExtendsOf()) {
                type = new Type.WildcardType(Type.WildcardType.Kind.EXTENDS, stage3TypeArgument.getType());
            } else {
                if (node.hasSuperOf()) {
                    type = new Type.WildcardType(Type.WildcardType.Kind.SUPER, stage3TypeArgument.getType());
                }
            }
        } else {
            type = stage3TypeArgument.getType();
        }
        this.typeList.add(type);

    }

    @Override
    public void end(TypeArgumentsListHelperNode node) throws CompilerException {
        this.typeList.addAll(this.stage3TypeArgumentsListHelper.getTypeList());
    
    }
    public List<Type> getTypes(){
        return this.typeList;
    }
}
