/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3.bridgeimplementation;

import abstractsyntaxtree.AssertStatementNode;
import abstractsyntaxtree.BlockNode;
import abstractsyntaxtree.BreakStatementNode;
import abstractsyntaxtree.ContinueStatementNode;
import abstractsyntaxtree.DoStatementNode;
import abstractsyntaxtree.ForStatementNode;
import abstractsyntaxtree.IdentDoublePointStatementNode;
import abstractsyntaxtree.IfStatementNode;
import abstractsyntaxtree.ReturnStatementNode;
import abstractsyntaxtree.StatementExpressionNode;
import abstractsyntaxtree.SwitchStatementNode;
import abstractsyntaxtree.SynchronizedStatementNode;
import abstractsyntaxtree.ThrowStatementNode;
import abstractsyntaxtree.TryStatementNode;
import abstractsyntaxtree.TypeSwitchStatementNode;
import abstractsyntaxtree.WhileStatementNode;
import codegeneration.Visitor;

/**
 *
 * @author Michael Burzan
 */
public interface StatementVisitorImpl {
    public void beginImpl(BlockNode node) throws exceptions.CompilerException;

    public void beginImpl(IdentDoublePointStatementNode node) throws exceptions.CompilerException;

    public void beginImpl(StatementExpressionNode node) throws exceptions.CompilerException;

    public void beginImpl(IfStatementNode node) throws exceptions.CompilerException;

    public void beginImpl(AssertStatementNode node) throws exceptions.CompilerException;

    public void beginImpl(SwitchStatementNode node) throws exceptions.CompilerException;

    public void beginImpl(WhileStatementNode node) throws exceptions.CompilerException;

    public void beginImpl(DoStatementNode node) throws exceptions.CompilerException;

    public void beginImpl(ForStatementNode node) throws exceptions.CompilerException;

    public void beginImpl(BreakStatementNode node) throws exceptions.CompilerException;

    public void beginImpl(ContinueStatementNode node) throws exceptions.CompilerException;

    public void beginImpl(ReturnStatementNode node) throws exceptions.CompilerException;

    public void beginImpl(ThrowStatementNode node) throws exceptions.CompilerException;

    public void beginImpl(SynchronizedStatementNode node) throws exceptions.CompilerException;

    public void beginImpl(TryStatementNode node) throws exceptions.CompilerException;

    public void beginImpl(TypeSwitchStatementNode node) throws exceptions.CompilerException;

    public Visitor visitImpl(BlockNode node) throws exceptions.CompilerException;

    public Visitor visitImpl(IdentDoublePointStatementNode node) throws exceptions.CompilerException;

    public Visitor visitImpl(StatementExpressionNode node) throws exceptions.CompilerException;

    public Visitor visitImpl(IfStatementNode node) throws exceptions.CompilerException;

    public Visitor visitImpl(AssertStatementNode node) throws exceptions.CompilerException;

    public Visitor visitImpl(SwitchStatementNode node) throws exceptions.CompilerException;

    public Visitor visitImpl(WhileStatementNode node) throws exceptions.CompilerException;

    public Visitor visitImpl(DoStatementNode node) throws exceptions.CompilerException;

    public Visitor visitImpl(ForStatementNode node) throws exceptions.CompilerException;

    public void visitImpl(BreakStatementNode node) throws exceptions.CompilerException;

    public void visitImpl(ContinueStatementNode node) throws exceptions.CompilerException;

    public Visitor visitImpl(ReturnStatementNode node) throws exceptions.CompilerException;

    public Visitor visitImpl(ThrowStatementNode node) throws exceptions.CompilerException;

    public Visitor visitImpl(SynchronizedStatementNode node) throws exceptions.CompilerException;

    public Visitor visitImpl(TryStatementNode node) throws exceptions.CompilerException;

    public Visitor visitImpl(TypeSwitchStatementNode node) throws exceptions.CompilerException;

    public void endImpl(BlockNode node) throws exceptions.CompilerException;

    public void endImpl(IdentDoublePointStatementNode node) throws exceptions.CompilerException;

    public void endImpl(StatementExpressionNode node) throws exceptions.CompilerException;

    public void endImpl(IfStatementNode node) throws exceptions.CompilerException;

    public void endImpl(AssertStatementNode node) throws exceptions.CompilerException;

    public void endImpl(SwitchStatementNode node) throws exceptions.CompilerException;

    public void endImpl(WhileStatementNode node) throws exceptions.CompilerException;

    public void endImpl(DoStatementNode node) throws exceptions.CompilerException;

    public void endImpl(ForStatementNode node) throws exceptions.CompilerException;

    public void endImpl(BreakStatementNode node) throws exceptions.CompilerException;

    public void endImpl(ContinueStatementNode node) throws exceptions.CompilerException;

    public void endImpl(ReturnStatementNode node) throws exceptions.CompilerException;

    public void endImpl(ThrowStatementNode node) throws exceptions.CompilerException;

    public void endImpl(SynchronizedStatementNode node) throws exceptions.CompilerException;

    public void endImpl(TryStatementNode node) throws exceptions.CompilerException;

    public void endImpl(TypeSwitchStatementNode node) throws exceptions.CompilerException;
}
