/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3.states;

import abstractsyntaxtree.SyntaxNode;
import exceptions.CompilerException;

/**
 *
 * @author Michael Burzan
 */
public interface State {

    State changeState(ConstructorState state, SyntaxNode node) throws CompilerException;

    State changeState(VoidMethodState state, SyntaxNode node) throws CompilerException;

    State changeState(AssertState state, SyntaxNode node) throws CompilerException;

    State changeState(BlockState state, SyntaxNode node) throws CompilerException;

    State changeState(DoState state, SyntaxNode node) throws CompilerException;

    State changeState(IdentDoublePointState state, SyntaxNode node) throws CompilerException;

    State changeState(IfState state, SyntaxNode node) throws CompilerException;

    State changeState(StatementExpressionState state, SyntaxNode node) throws CompilerException;

    State changeState(WhileState state, SyntaxNode node) throws CompilerException;

    State changeState(ForState state, SyntaxNode node) throws CompilerException;

    State changeState(BreakState state, SyntaxNode node) throws CompilerException;

    State changeState(ContinueState state, SyntaxNode node) throws CompilerException;

    State changeState(ReturnState state, SyntaxNode node) throws CompilerException;

    State changeState(ThrowState state, SyntaxNode node) throws CompilerException;

    State changeState(SynchronizedState state, SyntaxNode node) throws CompilerException;

    State changeState(TryState state, SyntaxNode node) throws CompilerException;

    State changeState(TypeSwitchState state, SyntaxNode node) throws CompilerException;

    State changeState(LocalVariableDeclarationState state, SyntaxNode node) throws CompilerException;

    State changeState(MethodState state, SyntaxNode node) throws CompilerException;

    State changeState(UnreachableCodeState state, SyntaxNode node) throws CompilerException;

    State getParent();
}
