/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package stage3.utils;

import codegeneration.environment.Stage3Environment;
import java.util.HashSet;
import java.util.Set;
import teajay.bytecode.ClassFile;
import teajay.bytecode.attributes.AttributeInfo;
import teajay.bytecode.fields.FieldAccessFlag;
import teajay.util.tjattribute.TeaJayAttribute;

/**
 *
 * @author Michael Burzan
 */
public class InformationCenter {
    private final Stage3Environment env;
    private Set<FieldAccessFlag> fieldProperties = new HashSet<>();
    private String fieldName;
    public InformationCenter(Stage3Environment env){
        this.env = env;
    }
    
    public static TeaJayAttribute.AccessType getTeaJayAccessType(ClassFile typeDef) {
        AttributeInfo attribute = typeDef.getAttribute(TeaJayAttribute.NAME);
        
        if (attribute == null) {
            if(typeDef.isAbstract()){
                return TeaJayAttribute.AccessType.Abstract;
            }
            if(typeDef.isInterface()){
                return TeaJayAttribute.AccessType.Abstract;
            }else{
                return TeaJayAttribute.AccessType.None;
            }
        }
        TeaJayAttribute tjAttr = (TeaJayAttribute) attribute;
        return tjAttr.getAccessType();
    }
    
    public static TeaJayAttribute.Type getTeaJayAttributeType(ClassFile typeDef) {
        AttributeInfo attribute = typeDef.getAttribute(TeaJayAttribute.NAME);
        
        if (attribute == null) {
            if(typeDef.isEnum()){
                return TeaJayAttribute.Type.Enum;
            }
            if(typeDef.isInterface()){
                return TeaJayAttribute.Type.Interface;
            }else{
                return TeaJayAttribute.Type.Class;
            }
        }
        TeaJayAttribute tjAttr = (TeaJayAttribute) attribute;
        return tjAttr.getType();
    }
    
}
