/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package teajay.runtime;

import static teajay.runtime.StringType.$_checkIndices;
import teajay.util.TJType;
import teajay.util.tjattribute.TeaJayAttribute.Type;

/**
 *
 * @author Michael Kußmann <michi@outx.de>
 */
@TJType(type = Type.Hidden)
public class CharSequenceType {

    public static CharSequence subSequence(CharSequence seq, teajay.lang.Number start, teajay.lang.Number end) {
        $_checkIndices(start, end);
        return seq.subSequence(start.$int_val(), end.$int_val());
    }

    public static String charAt(CharSequence seq, teajay.lang.Number index) {
        $_checkIndices(index);
        return String.valueOf(seq.charAt(index.$int_val())).intern();
    }

    public static teajay.lang.Number length(CharSequence seq) {
        return teajay.lang.Number.$valueOf(seq.length());
    }
    
    public static teajay.lang.Number tjHashCode(CharSequence seq) {
        return teajay.lang.Number.$valueOf(seq.hashCode());
    }
}
