/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package teajay.util;

import teajay.runtime.TJTypes;
import teajay.util.tjattribute.TeaJayAttribute;
import teajay.lang.Number;
/**
 * Preliminary math library for TeaJay.
 * @author Michael Kußmann <michi@outx.de>
 */
@TJType(type = TeaJayAttribute.Type.Typedef, accessType = TeaJayAttribute.AccessType.Abstract)
public abstract class Math {
    @TJType(accessType = TeaJayAttribute.AccessType.Hidden)
    public Math() {
    }
    
    public static Number exp(teajay.lang.Number x) {
        return (Number) TJTypes.invokeStatic(Math.class, "exp", x);
    }

    public static teajay.lang.Number exp(teajay.lang.Number x, teajay.lang.Number precision) {
        return (Number) TJTypes.invokeStatic(Math.class, "exp", x, precision);
    }
    
    public static teajay.lang.Number pow(teajay.lang.Number x, teajay.lang.Number n) {
        return (Number) TJTypes.invokeStatic(Math.class, "pow", x, n);
    }
    
    public static teajay.lang.Number pow(teajay.lang.Number x, teajay.lang.Number n, teajay.lang.Number precision) {
        return (Number) TJTypes.invokeStatic(Math.class, "pow", x, n, precision);
    }

    public static teajay.lang.Number faculty(teajay.lang.Number x) {
        return (Number) TJTypes.invokeStatic(Math.class, "faculty", x);
    }
    
    public static teajay.lang.Number ln(teajay.lang.Number a) {
        return (Number) TJTypes.invokeStatic(Math.class, "ln", a);
    }

    public static teajay.lang.Number ln(teajay.lang.Number a, teajay.lang.Number precision) {
        return (Number) TJTypes.invokeStatic(Math.class, "ln", a, precision);
    }

    public static teajay.lang.Number sqrt(teajay.lang.Number x) {
        return (Number) TJTypes.invokeStatic(Math.class, "sqrt", x);
    }
    
    public static teajay.lang.Number sqrt(teajay.lang.Number x, teajay.lang.Number precision) {
        return (Number) TJTypes.invokeStatic(Math.class, "sqrt", x, precision);
    }
}
