/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package teajay.util;

import teajay.lang.Closure;
import teajay.lang.RandomAccess;
import teajay.lang.TJComparable;
import teajay.lang.TJObject;
import teajay.runtime.TJTypes;
import teajay.util.tjattribute.TeaJayAttribute;

/**
 * TeaJay type for sorting RandomAccess.
 * @author Michael Kußmann <michi@outx.de>
 */
@TJType(type = TeaJayAttribute.Type.Typedef, accessType = TeaJayAttribute.AccessType.Final)
public abstract class Sorter extends TJObject {
    private static final Class<?>[] sort1 = new Class<?>[] {RandomAccess.class};
    private static final Class<?>[] sort2 = new Class<?>[] {RandomAccess.class, Closure.class};
    
    @TJType(accessType = TeaJayAttribute.AccessType.Hidden)
    public Sorter() {
    }
    
    @TJSignature("<T:Ljava/lang/Object;>(Lteajay/lang/RandomAccess<TT;>;Lteajay/lang/Closure<Lteajay/lang/Number;TT;TT;>;)V")
    public static <T> void sort(RandomAccess<T> list, Closure comparator) {
        TJTypes.invokeStatic(Sorter.class, "sort", sort2, list, comparator);
    }
    
    public static <T extends TJComparable<? super T>> void sort(RandomAccess<T> list) {
        TJTypes.invokeStatic(Sorter.class, "sort", sort1, list);
    }
}
